/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		THIS IS THE DEFINITION YOU NEED ON PLUGIN

/************************************************************************/

#ifndef	GSFDM_URL_LIST_SHARED
#define	GSFDM_URL_LIST_SHARED

#include	<glib.h>

/************************************************************************/
//	structure and define definition
/************************************************************************/
#ifndef GsfdmUrlState
typedef	enum {
	GSFDM_URL_STATE_WAIT,			// url entry is sceduled
	GSFDM_URL_STATE_RUNNING,		// url is downloading
	GSFDM_URL_STATE_DONE,			// downloaded
	GSFDM_URL_STATE_DEAD,			// answer is dead : can't download
	GSFDM_URL_STATE_PARTIAL			// downloading has been stopped
} GsfdmUrlState;
#endif GsfdmUrlState

// this is the struc shared between gsfdm and plugin ;
// only field host, percent and size are alowed to change by plugin
// other are to considered read-only
#ifndef st_gsfdm_url_entry_shared
typedef struct {
	gchar	*url;				// string of the source : or url
	gchar	*name;				// name used for save
	gchar	*path;				// rep where saved
	gchar	*host;				// host of download

	gfloat	percent;			// percentage of download
	glong	size;				// Kb done
	gint	pid;				// pid of child running the download
} st_gsfdm_url_entry_shared;

#define ST_GSFDM_URL_ENTRY_SHARED( s ) ( (( st_gsfdm_url_entry_shared *)s) )
#define gsfdm_url_st_shared_get_url( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->url )
#define gsfdm_url_st_shared_get_name( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->name )
#define gsfdm_url_st_shared_get_path( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->path )
#define gsfdm_url_st_shared_get_host( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->host )
#define gsfdm_url_st_shared_get_percent( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->percent )
#define gsfdm_url_st_shared_get_size( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->size )
#define gsfdm_url_st_shared_get_pid( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->pid )

#endif st_gsfdm_url_entry_shared


/************************************************************************/
// simply struct for making life easier, all in read-only access
#ifndef st_gsfdm_config_proxy
typedef struct {
	gboolean	use_proxy;
	gchar		*user;
	gchar		*pass;
	gchar		*proxy_url;
} st_gsfdm_config_proxy;

#define ST_GSFDM_CONFIG_PROXY( s ) ( ((st_gsfdm_config_proxy *)s) )
#define gsfdm_proxy_st_get_use_proxy( s ) ( ST_GSFDM_CONFIG_PROXY( s )->use_proxy  )
#define gsfdm_proxy_st_get_user( s ) ( ST_GSFDM_CONFIG_PROXY( s )->user  )
#define gsfdm_proxy_st_get_pass( s ) ( ST_GSFDM_CONFIG_PROXY( s )->pass  )
#define gsfdm_proxy_st_get_proxy_url( s ) ( ST_GSFDM_CONFIG_PROXY( s )->proxy_url  )

#endif st_gsfdm_config_proxy

#endif GSFDM_URL_LIST_SHARED
