/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		Header for plugin operations

/************************************************************************/

#ifndef	GSFDM_ASF
#define	GSFDM_ASF

#include	<glib.h>
#include	"./gsfdm_plugin_shared.h"

/************************************************************************/
//	structure and define definition
/************************************************************************/

/************************************************************************/
//	functions definition
/************************************************************************/
// this is the list of all functions defined. all MUST be present, otherwise, the plugin loader
// will cancel use of the library


/************************************************************************/
//	first call ( after loading through g_module_open and symbols resolving )
// here you do things the plug need at startup
// return TRUE on success
gboolean	plug_init( void );

/************************************************************************/
// need more explaination ???
// if safe=TRUE; ask plugin, if could,  not stop current work : push it at backgroud
gboolean	plug_stop( gboolean safe );

/************************************************************************/
// return a static string for the full plug name, used at display
gchar const *plug_get_name( void );

/************************************************************************/
// version number ; typ return( VERSION );
gchar const	*plug_get_version( void );

/************************************************************************/
// return array to const gchar * of all authors names
gchar const	**plug_get_author( void );

/************************************************************************/
// data for and icon or ( NULL if nome ), this is the variable 
// created when you included an XPM icon
gchar const	**plug_get_icon( void );

/************************************************************************/
// return version of gsfdm this plug was created for ;
// perhaps usefull further if the interface changed...
gchar const *plug_get_gsfdm_version( void );

/************************************************************************/
// a comment ; description of plug
gchar const *plug_get_comment( void );

/************************************************************************/
// return null ending array of supported protocol [] = { "http:", "https:", NULL };
gchar const	**plug_get_protocol_list( void );

/************************************************************************/
// this is the list of HD FILE the plug is able to parse.
// exemple : .asf that enclose stream info
// null if none
gchar const	**plug_get_ext_list( void );

/************************************************************************/
// TRUE if provide a gnome dlg for configuration
gboolean	plug_have_gnome_config( void );

/************************************************************************/
// return the top widget of the dlg in a form of gpointer
// this is for compatibility if no gnome support
gpointer	plug_get_gnome_dlg( void );

/************************************************************************/
// start dowloading this job, return pid of child running it ( or 0 on error )
guint	plug_start_job( st_gsfdm_url_entry_shared *s, st_gsfdm_config_proxy *proxy );

/************************************************************************/
// request abort downloading of this job - identify it with pid...
// TRUE if successful ; you have to take care of kill child pid by yourself
gboolean	plug_stop_job( st_gsfdm_url_entry_shared *s );

/************************************************************************/
// update infos ( percent, size ) and return the state ( after update )
GsfdmUrlState plug_update_job( st_gsfdm_url_entry_shared *s );

/************************************************************************/
// when loading from disk, gsfdm request the plug to parse the
// description file ( like m3u, asx... )
// return true on success, read data fron input stream, write '\n' ending
// string into output ( flush after each write ), extension of the 
// file to parse if you need it...
gboolean	plug_parse_file( FILE *input, FILE *output, gchar const *ext );


#endif	GSFDM_ASF
