/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		THIS IS THE DEFINITION YOU NEED ON PLUGIN

/************************************************************************/

#ifndef	GSFDM_URL_LIST_SHARED
#define	GSFDM_URL_LIST_SHARED

#include	<glib.h>

/************************************************************************/
//	structure and define definition
/************************************************************************/
#ifndef GsfdmUrlState
typedef	enum {
	GSFDM_URL_STATE_WAIT,			// url entry is sceduled
	GSFDM_URL_STATE_RUNNING,		// url is downloading
	GSFDM_URL_STATE_DONE,			// downloaded
	GSFDM_URL_STATE_DEAD,			// answer is dead : can't download
	GSFDM_URL_STATE_PARTIAL,		// downloading has been stopped
	GSFDM_URL_STATE_UNABLE,			// unable to get data
	
	// only used for communication
	GSFDM_URL_STATE_MASK = 0x7fff,	// just bit for state
	GSFDM_URL_CHANGE_MASK = 0x8000	// just bit that state a change in data ( dif from blank update... )
} GsfdmUrlState;
#endif GsfdmUrlState

// this is the struc shared between gsfdm and plugin ;
// only field host, percent and size are alowed to change by plugin
// other are to considered read-only
#ifndef st_gsfdm_url_entry_shared
typedef struct {
	gchar	*url;				// string of the source : or url
	gchar	*name;				// name used for save
	gchar	*path;				// rep where saved
	gchar	*host;				// host of download

	gfloat	percent;			// percentage of download
	glong	size;				// byte done
	gint	pid;				// pid of child running the download
	glong	total;				// total size, 0 if unknow so the use of 'percent'
} st_gsfdm_url_entry_shared;

#define ST_GSFDM_URL_ENTRY_SHARED( s ) ( (( st_gsfdm_url_entry_shared *)s) )
#define gsfdm_url_st_shared_get_url( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->url )
#define gsfdm_url_st_shared_get_name( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->name )
#define gsfdm_url_st_shared_get_path( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->path )
#define gsfdm_url_st_shared_get_host( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->host )
#define gsfdm_url_st_shared_get_percent( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->percent )
#define gsfdm_url_st_shared_get_size( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->size )
#define gsfdm_url_st_shared_get_pid( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->pid )
#define gsfdm_url_st_shared_get_total( s ) ( ST_GSFDM_URL_ENTRY_SHARED( s )->total )

#endif st_gsfdm_url_entry_shared

/************************************************************************/
// simply struct for making life easier, all in read-only access
#ifndef st_gsfdm_config_proxy
typedef struct {
	gboolean	use_proxy;
	gchar		*user;
	gchar		*pass;
	gchar		*proxy_url;
} st_gsfdm_config_proxy;

#define ST_GSFDM_CONFIG_PROXY( s ) ( ((st_gsfdm_config_proxy *)s) )
#define gsfdm_proxy_st_get_use_proxy( s ) ( ST_GSFDM_CONFIG_PROXY( s )->use_proxy  )
#define gsfdm_proxy_st_get_user( s ) ( ST_GSFDM_CONFIG_PROXY( s )->user  )
#define gsfdm_proxy_st_get_pass( s ) ( ST_GSFDM_CONFIG_PROXY( s )->pass  )
#define gsfdm_proxy_st_get_proxy_url( s ) ( ST_GSFDM_CONFIG_PROXY( s )->proxy_url  )

#endif st_gsfdm_config_proxy

/************************************************************************/
// this is a struc intented, with functions shared, to make life easier
// if you don't really know how the use it is, have a look to asf plug...
// there steam and descriptor, of course it depend of our use, asf only use 
// stream for exemple...
#ifndef st_gsfdm_job
typedef struct {
	gchar	*path;				// path to the dest file.. in case...
	pid_t	pid;				// pid of process
	int		read_d;				// descriptor for read data from command....
	int		write_d;			// if you really need ( ??? )
	FILE	*stream;			// have a look at popen, don't make life harder than
								// it's already is....
	gpointer data;				// optional data, useful, sometimes
} st_gsfdm_job;

#define ST_GSFDM_JOB( s ) ( ((st_gsfdm_job *)s) )
#define st_gsfdm_job_get_path( s ) ( ST_GSFDM_JOB( s )->path )
#define st_gsfdm_job_get_pid( s ) ( ST_GSFDM_JOB( s )->pid )
#define st_gsfdm_job_get_read( s ) ( ST_GSFDM_JOB( s )->read_d )
#define st_gsfdm_job_get_write( s ) ( ST_GSFDM_JOB( s )->write_d  )
#define st_gsfdm_job_get_stream( s ) ( ST_GSFDM_JOB( s )->stream  )
#define st_gsfdm_job_get_data( s ) ( ST_GSFDM_JOB( s )->data  )

#define st_gsfdm_job_new() ( g_new0( st_gsfdm_job, 1 ) )

// a macro for destructor... thanks glib
#define st_gsfdm_job_destroy(s) G_STMT_START{ 			\
	if( st_gsfdm_job_get_path( (s) ) ) 					\
	{	g_free( st_gsfdm_job_get_path( (s) ) ); };		\
	if( st_gsfdm_job_get_stream( (s) ) ) 				\
	{	fclose( st_gsfdm_job_get_stream( (s) ) ); };	\
	if( st_gsfdm_job_get_read( (s) ) ) 					\
	{	close( st_gsfdm_job_get_read( (s) ) ); };		\
	if( st_gsfdm_job_get_write( (s) ) ) 				\
	{	close( st_gsfdm_job_get_write( (s) ) ); };		\
	g_free( s );				}G_STMT_END

	
	
#endif st_gsfdm_job

#endif GSFDM_URL_LIST_SHARED
