#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <string.h>
#include <regex.h>
#include <stdio.h>

#define	HTML_MAIN_TOKEN_START	"<[[:blank:]]*HTML[[:blank:]]*>"
#define HTML_MAIN_TOKEN_END 	"<[[:blank:]]*/HTML[[:blank:]]*>"
#define	HTML_BODY_TOKEN_START	"<[[:blank:]]*BODY[^<>]*>"
#define HTML_BODY_TOKEN_END 	"<[[:blank:]]*/BODY[[:blank:]]*>"
#define	HTML_BASE_TOKEN			"<[[:blank:]]*BASE[[:blank:]]+HREF=(\"|'|`)([^\"'`]+)\\1[[:blank:]]*>"
#define	HTML_REF_TOKEN			"<[[:blank:]]*A[[:blank:]]+HREF=(\"|'|`)([^\"'`]+)\\1[^<>]*>"

main( int argc, gchar *argv[] )
{
static regex_t		*main_tag_start, *main_tag_end, *body_tag_start, *body_tag_end, *base_tag, *ref_tag;
static regmatch_t	main_m[4], ref_m[4];
gchar		*str, *str_tmp, *host = NULL;
gboolean	is_html = FALSE;
	
	main_tag_start = g_new0( regex_t, 1 );
	main_tag_end = g_new0( regex_t, 1 );
	body_tag_start = g_new0( regex_t, 1 );
	body_tag_end = g_new0( regex_t, 1 );
	base_tag = g_new0( regex_t, 1 );
	ref_tag = g_new0( regex_t, 1 );
	
	if( regcomp( main_tag_start, HTML_MAIN_TOKEN_START, REG_ICASE | REG_EXTENDED ) )
	{	g_print( "1 compile pas...\n");
		exit( 255 );
	}
	if( regcomp( main_tag_end, HTML_MAIN_TOKEN_END, REG_ICASE | REG_EXTENDED ) )
	{	g_print( "1' compile pas...\n");
		exit( 255 );
	}

	if( regcomp( body_tag_start, HTML_BODY_TOKEN_START, REG_ICASE | REG_EXTENDED ) )
	{	g_print( "2 compile pas...\n");
		exit( 255 );
	}
	if( regcomp( body_tag_end, HTML_BODY_TOKEN_END, REG_ICASE | REG_EXTENDED ) )
	{	g_print( "2' compile pas...\n");
		exit( 255 );
	}

	
	if( regcomp( base_tag, HTML_BASE_TOKEN, REG_ICASE | REG_EXTENDED ) )
	{	g_print( "3 compile pas...\n");
		exit( 255 );
	}

	if( regcomp( ref_tag, HTML_REF_TOKEN, REG_ICASE | REG_EXTENDED ) )
	{	g_print( "4 compile pas...\n");
		exit( 255 );
	}
	
	if( argc < 1 )
	exit(255 );
	
	{	FILE	*f = fopen( argv[1], "r" );
		
		str = (gchar *)malloc( 60000 );
		fread( str, sizeof( gchar ), 60000, f );
		fclose( f );
	}
	
	str_tmp = str;
	
	// found start, step start of string
	if( !regexec( main_tag_start, str, 4, main_m, 0 ) )
	{	g_print( "%d %d\n", main_m[0].rm_so, main_m[0].rm_eo );
		
		// found end, mark new end
		if( !regexec( main_tag_end, ( str = str + main_m[0].rm_eo ), 4, main_m, 0 ) )
		{	str[ main_m[0].rm_so ] = 0;
			g_print( "%d %d\n", main_m[0].rm_so, main_m[0].rm_eo );
			
			if( !regexec( body_tag_start, str, 4, main_m, 0 ) )
			{	g_print( "%d %d\n", main_m[0].rm_so, main_m[0].rm_eo );
				
				if( !regexec( body_tag_end, ( str = str + main_m[0].rm_eo ), 4, main_m, 0 ) )
				{	str[ main_m[0].rm_so ] = 0;
					g_print( "%d %d\n", main_m[0].rm_so, main_m[0].rm_eo );

					is_html = TRUE;
				}
				
			}
		}
	}
	
	if ( !is_html )
	{	g_print( "match pas un html... ???\n");
		g_free( str_tmp );
		exit( 255 );
	}

	// base token
	if( !regexec( base_tag, str_tmp, 4, main_m, 0 ) )
	{	host = g_strndup( str_tmp + main_m[2].rm_so, main_m[2].rm_eo - main_m[2].rm_so );
		
		g_print( "base token trouve : %s\n", host );
		
	}
	
	while( !regexec( ref_tag, str, 4, main_m, 0 ) )
	{	gchar *ref = g_strndup( str + main_m[2].rm_so, main_m[2].rm_eo - main_m[2].rm_so );
		str += ( main_m[0].rm_eo + 1 );
		
		g_print( "---> %s\n", ref );	
	}
		
	g_free( str_tmp );
}













