/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		Header for all configuration operations ( dlg, load, save... )

/************************************************************************/

#ifndef	GSFDM_CONFIG
#define	GSFDM_CONFIG

#include	<gnome.h>

/************************************************************************/
//	structure and define definition
/************************************************************************/
// simply struct for making life easier
typedef struct {
	gboolean	use_proxy;
	gchar		*user;
	gchar		*pass;
	gchar		*proxy_url;
} st_gsfdm_config_proxy;

#define ST_GSFDM_CONFIG_PROXY( s ) ( ((st_gsfdm_config_proxy *)s) )
#define gsfdm_proxy_st_get_use_proxy( s ) ( ST_GSFDM_CONFIG_PROXY( s )->use_proxy  )
#define gsfdm_proxy_st_get_user( s ) ( ST_GSFDM_CONFIG_PROXY( s )->user  )
#define gsfdm_proxy_st_get_pass( s ) ( ST_GSFDM_CONFIG_PROXY( s )->pass  )
#define gsfdm_proxy_st_get_proxy_url( s ) ( ST_GSFDM_CONFIG_PROXY( s )->proxy_url  )

#define	st_gsfdm_config_proxy_new( ) ( g_new0( st_gsfdm_config_proxy, 1 ) )
void st_gsfdm_config_proxy_destroy( st_gsfdm_config_proxy *s );

/************************************************************************/
//	functions definition
/************************************************************************/
// display, and create, the configuration box
void	gsfdm_config_open( void );

/************************************************************************/
// load the global config of the gui
void	gsfdm_config_load( void );

/************************************************************************/
// save the global config of the gui
void	gsfdm_config_save( void );

/************************************************************************/
//	return the struct for proxy config
st_gsfdm_config_proxy const *gsfdm_config_get_proxy( void );

/************************************************************************/
gboolean	gsfdm_config_get_warm_emply_job( void );

/************************************************************************/
gboolean	gsfdm_config_prompt_before_removing( void );
	
/************************************************************************/
gboolean	gsfdm_config_auto_remove_when_done( void );

/************************************************************************/
// return whether to switch auto download by default on or not
gboolean	gsfdm_config_get_auto_download( void );

/************************************************************************/
gboolean	gsfdm_config_get_auto_rename( void );

/************************************************************************/
gboolean	gsfdm_config_get_auto_parse( void );

/************************************************************************/
gboolean	gsfdm_config_open_popup_on_dnd( void );

/************************************************************************/
guint		gsfdm_config_get_update_time( void );

/************************************************************************/
guint		gsfdm_config_max_simultaneous( void );

/************************************************************************/
guint		gsfdm_config_get_timeout_on_download( void );

/************************************************************************/
gchar const *gsfdm_config_get_default_save_dir( void );

/************************************************************************/
gchar const *gsfdm_config_get_pppd( void );


#endif	GSFDM_CONFIG
