/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		Header for editing an entry

/************************************************************************/

#include	<gnome.h>
#include	<gnome_path.h>
#include	"gsfdm_edit.h"
#include	"gsfdm_url.h"
#include	"gsfdm_info.h"
#include	"gsfdm_plugin.h"

/************************************************************************/
//	debug support ( compiling flag )
/************************************************************************/

/************************************************************************/
//	static functions definition
/************************************************************************/
static void ok_callback( GnomeDialog *dlg );
static void cancel_callback( GnomeDialog *dlg );
static void option_plug_callback( GtkWidget *w, gpointer data );

/************************************************************************/
//	static variables definition
/************************************************************************/

/************************************************************************/
//	functions definition
/************************************************************************/
//	create and display a dlg for editing this entry
// there lot of widget, use many resources to create but by deleting
// each time allow multiple edit at time
void	gsfdm_edit_entry( guint entry_id )
{
st_gsfdm_url_entry	*s = gsfdm_url_get_url_data( entry_id );
GnomeDialog			*dlg;
GtkTable			*t;
GtkWidget			*auto_dl, *auto_rn, *name, *path, *url, *plug;
	
	if( !s )					// valid ???
		return;
	
//	if( !gsfdm_url_can_edit( entry_id ) )
//		return
	
	dlg = GNOME_DIALOG( gnome_dialog_new( _( "Edit URL" ), GNOME_STOCK_BUTTON_OK, GNOME_STOCK_BUTTON_CANCEL, NULL ) );
	gtk_box_set_spacing( GTK_BOX( dlg->vbox ), 5 );
	gnome_dialog_set_default( dlg, 0 );

	gnome_dialog_button_connect_object( dlg, 0, GTK_SIGNAL_FUNC( ok_callback ), GTK_OBJECT( dlg ) );
	gnome_dialog_button_connect_object( dlg, 1, GTK_SIGNAL_FUNC( cancel_callback ), GTK_OBJECT( dlg ) );
	gtk_signal_connect( GTK_OBJECT( dlg ), "delete_event", GTK_SIGNAL_FUNC( cancel_callback ), NULL );
	
	gtk_box_pack_start( GTK_BOX( dlg->vbox ),
		GTK_WIDGET( t = GTK_TABLE( gtk_table_new( 2, 4, FALSE ) ) ), FALSE, FALSE, 5 );
	
	gtk_table_attach( t, gtk_label_new( _( "Name" ) ), 0, 1, 0, 1, 0,0,0,0 );
	gtk_table_attach( t, gtk_label_new( _( "Path" ) ), 0, 1, 1, 2, 0,0,0,0 );
	gtk_table_attach( t, gtk_label_new( _( "Url" ) ), 0, 1, 2, 3, 0,0,0,0 );
	gtk_table_attach( t, gtk_label_new( _( "Plug" ) ), 0, 1, 3, 4, 0,0,0,0 );

	gtk_table_attach( t, ( name = gtk_entry_new() ), 1, 2, 0, 1,GTK_FILL | GTK_EXPAND,0,0,0 );
	gtk_table_attach( t, ( path = GTK_WIDGET( gnome_path_new() ) ), 1, 2, 1, 2, GTK_FILL | GTK_EXPAND,0,0,0 );
	gtk_table_attach( t, ( url = gtk_entry_new() ), 1, 2, 2, 3, GTK_FILL | GTK_EXPAND,0,0,0 );
	gtk_table_attach( t, ( plug = gtk_option_menu_new() ), 1, 2, 3, 4, GTK_FILL | GTK_EXPAND,0,0,0 );
	
	gtk_box_pack_start( GTK_BOX( dlg->vbox ), 
		( auto_dl = gtk_check_button_new_with_label( _( "Auto Download" ) ) ), FALSE, FALSE, 0 );
	gtk_box_pack_start( GTK_BOX( dlg->vbox ), 
		( auto_rn = gtk_check_button_new_with_label( _( "Auto Rename" ) ) ), FALSE, FALSE, 0 );
	
	// set data
	gtk_entry_set_text( GTK_ENTRY( name ), gsfdm_url_st_get_name( s ) );
	gnome_path_set_path( GNOME_PATH( path ), gsfdm_url_st_get_path( s ), TRUE );
	gtk_entry_set_text( GTK_ENTRY( url ), gsfdm_url_st_get_url( s ) );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( auto_dl ), gsfdm_url_st_get_auto_dl( s ) );
	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( auto_rn ), gsfdm_url_st_get_auto_rn( s ) );
	
	// fill the plug menu
	{	GtkWidget	*w, *menu;
		GList		*l, *tmp;
	
		menu = gtk_menu_new();
		tmp = l = g_list_first( g_list_append( gsfdm_plug_get_list(), (gpointer)g_strdup( "none" ) ) );

		while( l )
		{	w = gtk_menu_item_new_with_label( (gchar *)( l->data ) );
			
			gtk_object_set_data( GTK_OBJECT( w ), "id", (gpointer)gsfdm_plugin_get_id_for_plugin( (gchar *)( l->data ) ) );
			g_free( l->data );
			gtk_signal_connect( GTK_OBJECT( w ), "activate", GTK_SIGNAL_FUNC( option_plug_callback ), (gpointer)dlg );
			gtk_menu_append( GTK_MENU( menu ), w );
			l = g_list_next( l );
		}
		
		g_list_free( tmp );
	
		gtk_option_menu_set_menu( GTK_OPTION_MENU( plug ), menu );
	}
	
	gtk_object_set_data( GTK_OBJECT( dlg ), "name", (gpointer)( name ) );
	gtk_object_set_data( GTK_OBJECT( dlg ), "path", (gpointer)( path ) );
	gtk_object_set_data( GTK_OBJECT( dlg ), "url", (gpointer)( url ) );
	gtk_object_set_data( GTK_OBJECT( dlg ), "plug", (gpointer)( plug ) );
	gtk_object_set_data( GTK_OBJECT( dlg ), "auto_dl", (gpointer)( auto_dl ) );
	gtk_object_set_data( GTK_OBJECT( dlg ), "auto_rn", (gpointer)( auto_rn ) );
	gtk_object_set_data( GTK_OBJECT( dlg ), "entry", (gpointer)( entry_id ) );
	gtk_object_set_data( GTK_OBJECT( dlg ), "plug", (gpointer)( plug ) );
	gtk_object_set_data( GTK_OBJECT( dlg ), "current_plug", (gpointer)gsfdm_url_st_get_plug_id( s ) );
	
	gtk_widget_show_all( GTK_WIDGET( dlg ) );
}

/************************************************************************/
static void ok_callback( GnomeDialog *dlg )
{
guint				entry_id = (guint)gtk_object_get_data( GTK_OBJECT( dlg ), "entry" );
st_gsfdm_url_entry	const *s = gsfdm_url_get_url_data( entry_id );


	g_free( gsfdm_url_st_get_url( s ) );
	gsfdm_url_st_get_url( s ) = g_strdup( gtk_entry_get_text( 
		GTK_ENTRY( gtk_object_get_data( GTK_OBJECT( dlg ), "url" ) ) ) );
	
	g_free( gsfdm_url_st_get_name( s ) ) ;
	gsfdm_url_st_get_name( s ) = g_strdup( gtk_entry_get_text( 
		GTK_ENTRY( gtk_object_get_data( GTK_OBJECT( dlg ), "name" ) ) ) );
		
	g_free( gsfdm_url_st_get_path( s ) );
		gsfdm_url_st_get_path( s ) = gnome_path_get_path( GNOME_PATH( gtk_object_get_data( GTK_OBJECT( dlg ), "path" ) ) );
	
	gsfdm_url_st_get_auto_dl( s ) = gtk_toggle_button_get_active( 
		GTK_TOGGLE_BUTTON( gtk_object_get_data( GTK_OBJECT( dlg ), "auto_dl" ) ) );
	
	gsfdm_url_st_get_auto_rn( s ) = gtk_toggle_button_get_active( 
		GTK_TOGGLE_BUTTON( gtk_object_get_data( GTK_OBJECT( dlg ), "auto_rn" ) ) );
	
	gsfdm_url_st_get_plug_id( s ) = (guint)gtk_object_get_data( GTK_OBJECT( dlg ), "current_plug" );
	
	gsfdm_url_release_edit( s );
	gsfdm_info_inform_for_change( entry_id );
	
	gtk_widget_destroy( GTK_WIDGET( dlg ) );
}

/************************************************************************/
static void cancel_callback( GnomeDialog *dlg )
{
guint	entry_id = (guint)gtk_object_get_data( GTK_OBJECT( dlg ), "entry" );

	gsfdm_url_release_edit( gsfdm_url_get_url_data( entry_id ) );
	gtk_widget_destroy( GTK_WIDGET( dlg ) );
}

/************************************************************************/
static void option_plug_callback( GtkWidget *w, gpointer data )
{	gtk_object_set_data( GTK_OBJECT( data ), "current_plug", gtk_object_get_data( GTK_OBJECT( w ), "id" ) );
}
