/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		Header for file manipulation

//		Mostly of these functions are part of my former file manager
//		and further shared library devoted to file manipulation

/************************************************************************/

#ifndef	GSFDM_FILEOP
#define	GSFDM_FILEOP

#include	<gnome.h>
#include	<sys/stat.h>

/************************************************************************/
//	structure and define definition
/************************************************************************/
// ok, there good stucf on gnu c library, but this creates a shared interface
// between all functions of the soft : cleaner
typedef enum {
	GSFDM_FILE_TYPE_ERROR = -1,					// need explanation ???
	GSFDM_FILE_TYPE_REGULAR = __S_IFREG,
	GSFDM_FILE_TYPE_DIR =__S_IFDIR ,
	GSFDM_FILE_TYPE_SOCKET = __S_IFSOCK,
	GSFDM_FILE_TYPE_C_DEVICE = __S_IFCHR,
	GSFDM_FILE_TYPE_B_DEVICE= __S_IFBLK,
	GSFDM_FILE_TYPE_FIFO = __S_IFIFO,
	GSFDM_FILE_TYPE_LINK = __S_IFLNK,

// mask for type code ; already done on value returned by gsfdm_file_get_file_type
	GSFDM_FILE_MASK_TYPE = __S_IFMT
} GsfdmFileType;

/************************************************************************/
//	functions definition
/************************************************************************/
// return the type of the file ; just prevent use of low level
// function in the code ( create a cleaner code )
GsfdmFileType	gsfdm_file_get_file_type( gchar const *file );

/************************************************************************/
// return stat from a file, storing data in an internal struct
struct stat const *gsfdm_file_get_file_stat_fast( gchar const *file, gboolean real );

/************************************************************************/
// return( a new GList with (g_new) of all readable file ( for user ) in this directory
// NULL on error or empty dir
GList	*gsfdm_file_get_file_from_dir( gchar const *dir_name );

/************************************************************************/
// return a g_new str matching the ext type of this url / file
// exytract also from url with inlined options
gchar  *gsfdm_file_extract_ext( gchar const *url );

/************************************************************************/
// return a g_new str matchuing the protocole ( http:// mms:// ... )
// if none ( i.e. hd file ), return "file:", "mms:"
gchar	*gsfdm_file_get_protocol( gchar const *url );

/************************************************************************/
//	return true if the url match a local protocol :
// proto could by a proto string or directly an url / file string
// proto local == 'file:', 'files:', '/' or NULL ( case returned by get_proto )
/************************************************************************/
gboolean	gsfdm_file_protocol_is_local( gchar const *proto );

/************************************************************************/
// ... extract the file name
gchar	*gsfdm_file_get_file_name( gchar const *url );

/************************************************************************/
// comput a new name for the file "url", into the rep "dest", if formated
// is true that meen url is hd format ( path ) and not like "http://ar/eu/h/machintruc?blabla"
gchar	*gsfdm_file_get_new_name( gchar const *url, gchar const *dest, gboolean formated );

/************************************************************************/
// launch command like sytem(), except than don't freeze parent until end of child
// if freeze is FALSE, and use a fork instead using sh. End command with & to create
// it's own session
// return child pid or 0 on error
pid_t	system_ext( gchar const *command, gboolean freeze );



#endif	GSFDM_FILEOP
