/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		Header for historic

/************************************************************************/

#ifndef	GSFDM_HISTORIC
#define	GSFDM_HISTORIC

#include	<gnome.h>
#include	<glib.h>
#include	<time.h>

/************************************************************************/
//	structure and define definition
/************************************************************************/
typedef enum {
	GSFDM_HISTORIC_REPLACE,
	GSFDM_HISTORIC_ASK,
	GSFDM_HISTORIC_SKIP,
} GsfdmHistoricMode;

// this define an entry into history
typedef struct {
	// public
	gchar	*url;
	time_t	date;
} st_gsfdm_historic_entry;

#define ST_GSFDM_HISTORIC_ENTRY( s ) ( (( st_gsfdm_historic_entry *)s) )
#define gsfdm_historic_st_get_url( s ) ( ST_GSFDM_HISTORIC_ENTRY( s )->url )
#define gsfdm_historic_st_get_date( s ) ( ST_GSFDM_HISTORIC_ENTRY( s )->date )

#define st_historic_entry_new() ( g_new0( st_gsfdm_historic_entry, 1 ) )

// a macro for destructor... thanks glib
#define st_historic_entry_destroy(s) G_STMT_START{ 			\
	if( gsfdm_historic_st_get_url( (s) ) ) 					\
	{	g_free( gsfdm_historic_st_get_url( (s) ) ); };		\
	g_free( s );				}G_STMT_END

/************************************************************************/
//	functions definition
/************************************************************************/
// return widget for configuration
GtkWidget	*gsfdm_historic_get_config_page( void );

/************************************************************************/
// load configuration from saved conf
void		gsfdm_historic_load_conf( void );

/************************************************************************/
// ...
void		gsfdm_historic_save_conf( void );

/************************************************************************/
// add url to historic, return FALSE if can't i.e. cancel add of this url
gboolean	gsfdm_historic_push_url( gchar *url );

/************************************************************************/
// popup the historic 
void		gsfdm_historic_open_historic( void );

#endif	GSFDM_HISTORIC
