/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		Header for message box

/************************************************************************/

#include	<gnome.h>
#include	<time.h>
#include	"gsfdm_message.h"
#include	"main.h"
#include	"gsfdm_log.h"
#include	"gsfdm_url.h"

/************************************************************************/
//	debug support ( compiling flag )
/************************************************************************/
#ifdef HAVE_DEBUG
#undef GSFDM_DEBUG_MESSAGE_DUMP_CODE
#undef GSFDM_DEBUG_MESSAGE_DUMP_MESSAGE
#endif

/************************************************************************/
//	static functions definition
/************************************************************************/
static void dock_callback( GtkButton *bp, gpointer d );
static void close_callback( GtkButton *bp, gpointer d );

/************************************************************************/
//	static variables definition
/************************************************************************/
static	GtkBox		*w = NULL;
static	GnomeLess	*less;
extern	GnomeAppBar	*status_bar;					// the status bar !

//static time_t	day_zero_time = 0;

/************************************************************************/
//	functions definition
/************************************************************************/

/************************************************************************/
// return the main message widget
/************************************************************************/
GtkWidget	*gsfdm_message_get_dock( void )
{
GtkBox			*b;
GtkWidget		*close_bp, *clear_bp, *dock_bp;

	// if no widget, create ( and initialize ) the box first
	if( !w )
	{
		w = GTK_BOX( gtk_hbox_new( FALSE, 0 ) );

		// tip of the day : try without and you'll understand the use of this line
		gtk_widget_ref( GTK_WIDGET( w ) );
	
		gtk_box_pack_start( w, GTK_WIDGET( less = GNOME_LESS( gnome_less_new() ) ), TRUE, TRUE, 5 );
		gtk_box_pack_start( w, GTK_WIDGET( b = GTK_BOX( gtk_vbox_new( FALSE, 0 ) ) ), FALSE, FALSE, 5 );
	
		gtk_box_pack_start( b, ( close_bp = gnome_stock_button( GNOME_STOCK_BUTTON_CLOSE ) ), FALSE, FALSE, 5 );
		gtk_box_pack_start( b, ( clear_bp = gnome_stock_button( GNOME_STOCK_PIXMAP_CLEAR ) ), FALSE, FALSE, 5 );
		gtk_box_pack_start( b, ( dock_bp = gnome_pixmap_button(
			 gnome_stock_pixmap_widget( NULL, GNOME_STOCK_PIXMAP_CONVERT ), _( "Un/Dock" ) ) ), FALSE, FALSE, 5 ); 
		
		gtk_signal_connect( GTK_OBJECT( close_bp ), "clicked", GTK_SIGNAL_FUNC( close_callback ), NULL );
		gtk_signal_connect_object( GTK_OBJECT( clear_bp ), "clicked", GTK_SIGNAL_FUNC( gnome_less_clear ), GTK_OBJECT( less ) );
		gtk_signal_connect( GTK_OBJECT( dock_bp ), "clicked", GTK_SIGNAL_FUNC( dock_callback ), NULL );
		 
		gtk_text_set_editable( less->text, FALSE );

		gtk_widget_show_all( GTK_WIDGET( w ) );
/*		
		// make the date when started, in time_t value
		{	struct tm date_of_the_day;
			
			memcpy( &date_of_the_day, localtime( time( NULL ) ), sizeof( struct tm ) );
			date_of_the_day.tm_sec = date_of_the_day.tm_min = date_of_the_day.tm_hour = 0;
			day_zero_time = mktime( &date_of_the_day );
		}
*/
	}
	
	return( GTK_WIDGET( w ) );
}

/************************************************************************/
// call for a dock, undock op, hide window
// PS : you could use gtk_signal_connect_object with GTK_OBJECT( MainDockItem )
// it works ( on linux x86 ) but it's bad, CAN'T KNOW how other unix will 
// compil this...
/************************************************************************/
static void dock_callback( GtkButton *bp, gpointer d )
{	gsfdm_main_dock_op( MAIN_DOCK_MESSAGE );
}
/************************************************************************/
static void close_callback( GtkButton *bp, gpointer d )
{	gsfdm_main_showhide_op( MAIN_DOCK_MESSAGE );
}

/************************************************************************/
// add a line to the message
// could add the time / date ; and could add to log file
/************************************************************************/
void		gsfdm_message_push_message( gchar const *message, gboolean print_date, gboolean status, gboolean push_log )
{
time_t			current_time;
static gchar	date_str[19];
gchar			*tmp;
	
	#ifdef GSFDM_DEBUG_MESSAGE_DUMP_MESSAGE
	printf( "debug message ; dump message - %d %d %d - %d : %s\n", print_date, status, push_log, strlen( message ), message );
	#endif
	
	// check if add the date, alway add the day, checking for date is boring : some message always need
	if( print_date )
	{	current_time = time( NULL );
		strftime( date_str, sizeof( date_str ), "%d %b - %H:%M:%S\0", localtime( &current_time ) );
		tmp = g_strdup_printf( "%s - %s", date_str, message );
				
	// just message, no date, no time	
	} else {
		tmp = g_strconcat( "        ", message, NULL );
	}
	
	#ifdef GSFDM_DEBUG_MESSAGE_DUMP_MESSAGE
	printf( "debug message ; formated message is : %s\n", tmp );
	#endif
	
	// add to message box
//	gtk_text_set_point( GTK_TEXT( less->text ), -1 );
	gtk_text_insert( GTK_TEXT( less->text ), NULL, NULL, NULL, message, -1 );
	gtk_text_insert( GTK_TEXT( less->text ), NULL, NULL, NULL, "\n", 1 );
	
	if( status )
		gsfdm_main_write_message( tmp );
	
	if( push_log )
		gsfdm_log_push_line( tmp );
	
	g_free( tmp );
}

/************************************************************************/
//	write a defined message, with and optionnal data
/************************************************************************/
void		gsfdm_message_push_code( GsfdmMessageCode c, gpointer data )
{
gchar	*tmp;

	#ifdef	GSFDM_DEBUG_MESSAGE_DUMP_CODE
	printf( "debug message ; dump code : %d \n", c );
	#endif
	
	switch( c )
	{	case MESS_START_DOWNLOAD :
			tmp = g_strconcat( _( "Start downloading : " ), gsfdm_url_st_shared_get_name( data ), NULL );
			gsfdm_message_push_message( tmp, FALSE, FALSE, TRUE );
			g_free( tmp );
			break;
		case MESS_FINISH_DOWNLOAD :
			tmp = g_strconcat( _( "Downloading Successful : " ), gsfdm_url_st_shared_get_name( data ), NULL );
			gsfdm_message_push_message( tmp, TRUE, FALSE, TRUE );
			g_free( tmp );
			break;
		case MESS_DOWNLOAD_STOPPED :
			tmp = g_strconcat( _( "Stop Download for : " ), gsfdm_url_st_shared_get_name( data ), NULL );
			gsfdm_message_push_message( tmp, FALSE, FALSE, FALSE );
			g_free( tmp );
			break;
		case MESS_DEAD_LINK :
			tmp = g_strconcat( _( "Get a Dead Link answer for : " ), gsfdm_url_st_shared_get_name( data ), NULL );
			gsfdm_message_push_message( tmp, TRUE, FALSE, TRUE );
			g_free( tmp );
			break;
		case MESS_ERROR :
			tmp = g_strconcat( _( "There was somthing wrong with " ), gsfdm_url_st_shared_get_name( data ), NULL );
			gsfdm_message_push_message( tmp, TRUE, FALSE, TRUE );
			g_free( tmp );
			break;
		case MESS_PARTIAL_LINK :
			tmp = g_strconcat( _( "Stopped Downloading of : " ), gsfdm_url_st_shared_get_name( data ), _( " before the end" ), NULL );
			gsfdm_message_push_message( tmp, TRUE, FALSE, TRUE );
			g_free( tmp );
			break;
		case MESS_UNKNOW_PROTOCOL :
			tmp = g_strconcat( _( "Unknow of to Download : " ), gsfdm_url_st_shared_get_name( data ), NULL );
			gsfdm_message_push_message( tmp, TRUE, FALSE, TRUE );
			g_free( tmp );
			break;
		case MESS_AUTO_DOWNLOAD :
			if( (gboolean)data == TRUE )
				gsfdm_message_push_message( _( "Switched Global Auto Download Switch to YES" ), TRUE, TRUE, TRUE );
			else			
				gsfdm_message_push_message( _( "Switched Global Auto Download Switch to NO" ), TRUE, TRUE, TRUE );
			break;			
		case MESS_NO_PPPD :
			gsfdm_message_push_message( _( "PPPd deamon is not running, download delayed..." ), TRUE, FALSE, FALSE );
			break;
		case MESS_PATH_CHANGED :
			tmp = g_strdup_printf( _( "Wrong path %s changed to %s" ),gsfdm_url_st_get_path( data ), g_get_home_dir() );
			gsfdm_message_push_message( tmp, FALSE, FALSE, TRUE );
			g_free( tmp );
			break;
		case MESS_NO_PLUGIN :
			tmp = g_strdup_printf( _( "No plugin or parse error for : %s; edit manually..." ), gsfdm_url_st_get_name( data ) );
			gsfdm_message_push_message( tmp, FALSE, FALSE, TRUE );
			g_free( tmp );
			break;
		case MESS_DISMISS :
			tmp = g_strdup_printf( _( "Dismiss %s from download..." ), (gchar *)( data ) );
			gsfdm_message_push_message( tmp, FALSE, FALSE, TRUE );
			g_free( tmp );
			break;
		case MESS_BEGIN	:
			gsfdm_message_push_message( _( "**** WELCOME, Entering new session... ****" ), TRUE, TRUE, TRUE );
			break;
		case MESS_EXIT :
			gsfdm_message_push_message( _( "**** EXIT of G.S.F.D.M. All job(s) scheduled finished ****" ), TRUE, FALSE, TRUE );
			break;
		case MESS_EXIT_ANYWAY :
			tmp = g_strdup_printf( _( "**** EXIT, killing %d job(s) running" ), gsfdm_url_nb_are_working() );
			gsfdm_message_push_message( tmp, FALSE, FALSE, TRUE );
			g_free( tmp );
			break;
		case MESS_EXIT_BACKGROUND :
			tmp = g_strdup_printf( _( "**** EXIT, living %d job(s) running at background" ), gsfdm_url_nb_are_working() );
			gsfdm_message_push_message( tmp, FALSE, FALSE, TRUE );
			g_free( tmp );
			break;
		case MESS_EXIT_PUSH_IN_BACK :
			gsfdm_message_push_message( _( "**** EXIT, continuing at background" ), FALSE, FALSE, TRUE );
			break;
		case MESS_EXIT_SAFE :
			tmp = g_strdup_printf( _( "**** SAFE EXIT scheduled : at least %d job(s) to be done before real exit" ), gsfdm_url_nb_are_working() );
			gsfdm_message_push_message( tmp, TRUE, TRUE, TRUE );
			g_free( tmp );
			break;
		case MESS_EXIT_SHUTDOWN_PPPD :
			tmp = g_strdup_printf( _( "**** EXIT and STOP of PPPD connection scheduled : at least %d job(s) to be done before" ), gsfdm_url_nb_are_working() );
			gsfdm_message_push_message( tmp, TRUE, TRUE, TRUE );
			g_free( tmp );
			break;
		case MESS_EXIT_SHUTDOWN_HOST :	
			tmp = g_strdup_printf( _( "**** SHUTDOWN OF SYSTEM scheduled : at least %d job(s) to be done before" ), gsfdm_url_nb_are_working() );
			gsfdm_message_push_message( tmp, TRUE, TRUE, TRUE );
			g_free( tmp );
			break;
	
		default :
			g_warning( "invalid message code" );
	}
}
