/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		Header for plugin operations

/************************************************************************/

#include	<gnome.h>
#include	<glib.h>
#include	<gmodule.h>
#include	<config.h>
#include	<stdarg.h>
#include	"gsfdm_plugin.h"
#include	"gsfdm_fileop.h"
#include	"gsfdm_config.h"
#include	"gsfdm_message.h"

/************************************************************************/
//	debug flag
/************************************************************************/
#ifdef HAVE_DEBUG 
#define	GSFDM_DEBUG_PLUG_LOADING			// getting plug name
#define	GSFDM_DEBUG_PLUG_LOADING_PARSING	// checking and caching plug data
#define GSFDM_DEBUG_PLUG_DLG				// opening / creating dlg for plug
#define GSFDM_DEBUG_PLUG_CHANGE_PLUG		// when switch in dlg for other plug
#define GSFDM_DEBUG_PLUG_LOAD_EXT			// when fill the ext menu
#define GSFDM_DEBUG_PLUG_DUMP_ENABLE_BP		// switch the "plug enable" bp
#define GSFDM_DEBUG_PLUG_FOUND_PLUG			// when try to found a plug for an url
#endif

/************************************************************************/
// 	private stucture and definition
/************************************************************************/
//	pointer to function in plugin, filled one at loading, save
// many call to g_module_get_symbol

// let's go for prototyping ! ; taugh part but make remain of soft so easier than
// I nearly feel guilty...

// type of prototype a plugin function could be....
typedef gpointer (*FUNC_pointer_void) ( void );
typedef gpointer (*FUNC_pointer_pointer) ( gpointer );
typedef gpointer * (*FUNC_ppointer_void) ( void );
typedef gpointer * (*FUNC_ppointer_pointer) ( gpointer );
typedef gint (*FUNC_int_void) ( void );
typedef gint (*FUNC_int_int) ( gint );
typedef gint (*FUNC_int_pointer) ( gpointer );
typedef gint (*FUNC_int_pointer_pointer) ( gpointer, gpointer );
typedef gint (*FUNC_int_pointer_pointer_pointer) ( gpointer, gpointer, gpointer );
typedef gint (*FUNC_int_pointer_pointer_pointer_pointer) ( gpointer, gpointer, gpointer, gpointer );

// yes, I Do love define... isn't easier than using these array_index and pointers functions ???
// all will be directly inlined further at compile time, this is a very fast and clean method ( tip for neebie )
#define PLUG_GET_FUNC_ARRAY( plug_id ) ( (GPtrArray *)( g_hash_table_lookup( plugin_func, (gpointer)plug_id ) ) )
#define PLUG_GET_ENABLED( plug_id ) ( (gboolean)( g_hash_table_lookup( plugin_enabled, (gpointer)plug_id ) ) )
#define PLUG_SET_ENABLED( plug_id, state ) ( g_hash_table_insert( plugin_enabled, (gpointer)plug_id, (gpointer)state ) )
#define PLUG_GET_MODULE( plug_id ) ( (GModule *)( g_hash_table_lookup( plugin_list, (gpointer)plug_id ) ) )

#define PLUG_GET_FROM_PROTO( proto ) ( (guint)( g_hash_table_lookup( plugin_proto, (gpointer)proto ) ) )
#define PLUG_GET_FROM_EXT( ext ) ( (guint)( g_hash_table_lookup( plugin_ext, (gpointer)ext ) ) )

// a define for each plug function, so i can access then 'virtualy' like any other function ; nice no ??
#define	plug_init( array ) ( (gboolean)((FUNC_int_void)g_ptr_array_index( ((GPtrArray *)array), PLUG_INIT ) )() )
#define	plug_stop( array, safe ) ( (gboolean)((FUNC_int_int)g_ptr_array_index( ((GPtrArray *)array), PLUG_STOP ) )( safe ) )
#define	plug_get_name( array ) ( (gchar *)((FUNC_pointer_void)g_ptr_array_index( ((GPtrArray *)array), PLUG_GET_NAME ) )() )
#define	plug_get_version( array ) ( (gchar *)((FUNC_pointer_void)g_ptr_array_index( ((GPtrArray *)array), PLUG_GET_VERSION ) )() )
#define	plug_get_author( array ) ( (gchar **)((FUNC_ppointer_void)g_ptr_array_index( ((GPtrArray *)array), PLUG_GET_AUTHOR ) )() )
#define	plug_get_icon( array ) ( (gchar **)((FUNC_ppointer_void)g_ptr_array_index( ((GPtrArray *)array), PLUG_GET_ICON ) )() )
#define	plug_get_gsfdm_version( array ) ( (gchar *)((FUNC_pointer_void)g_ptr_array_index( ((GPtrArray *)array), PLUG_GET_GSFDM_VERSION ) )() )
#define	plug_get_comment( array ) ( (gchar *)((FUNC_pointer_void)g_ptr_array_index( ((GPtrArray *)array), PLUG_GET_COMMENT ) )() )
#define	plug_get_protocol_list( array ) ( (gchar **)((FUNC_ppointer_void)g_ptr_array_index( ((GPtrArray *)array), PLUG_GET_PROTOCOL_LIST ) )() )
#define	plug_get_ext_list( array ) ( (gchar **)((FUNC_ppointer_void)g_ptr_array_index( ((GPtrArray *)array), PLUG_GET_EXT_LIST ) )() )
#define	plug_have_gnome_config( array ) ( (gboolean)((FUNC_int_void)g_ptr_array_index( ((GPtrArray *)array), PLUG_HAVE_GNOME_CONFIG  ) )() )
#define	plug_get_gnome_dlg( array ) ( (gpointer)((FUNC_pointer_void)g_ptr_array_index( ((GPtrArray *)array), PLUG_GET_GNOME_DLG ) )() )
#define	plug_parse_file( array, i,o,s,e ) ( (gpointer)((FUNC_int_pointer_pointer_pointer_pointer)g_ptr_array_index( ((GPtrArray *)array), PLUG_PARSE_FILE ) )( i,o,s,e ) )
#define	plug_start_job( array, s, p ) ( (gpointer)((FUNC_int_pointer_pointer)g_ptr_array_index( ((GPtrArray *)array), PLUG_START_JOB ) )( s, p ) )
#define	plug_stop_job( array, s ) ( (gboolean)((FUNC_int_pointer)g_ptr_array_index( ((GPtrArray *)array), PLUG_STOP_JOB ) )( s ) )
#define	plug_update_job( array, s ) ( (GsfdmUrlState)((FUNC_int_pointer)g_ptr_array_index( ((GPtrArray *)array), PLUG_UPDATE_JOB ) )( s ) )

gchar	*GsfdmPluginFunctionName[] = {
	"plug_init","plug_stop","plug_get_name","plug_get_version","plug_get_author","plug_get_icon","plug_get_gsfdm_version",
	"plug_get_comment","plug_get_protocol_list","plug_get_ext_list","plug_have_gnome_config","plug_get_gnome_dlg",
	"plug_parse_file","plug_start_job","plug_stop_job","plug_update_job", NULL
	};

/************************************************************************/
//	static variables definition
/************************************************************************/
// there 3 hash : 
//		one with the GModule returned when opening plugin,
//		one with a gPtrArray, filled at opening with prt on all functions
// 		one with just a flag telling whether this plug could be used

static GHashTable	*plugin_list = NULL;		// key : plug_id, data : GModule
static GHashTable	*plugin_func = NULL;		// key : plug_id, data : GPtrArray
static GHashTable	*plugin_enabled = NULL;		// key : plug_id, data : gboolean

static GHashTable	*plugin_proto = NULL;		// key : "proto", data ! plug_id
static GHashTable	*plugin_ext = NULL;			// key : "ext", data ! plug_id
	
	
static gboolean	plugin_initialized = FALSE;			// TRUE : struct created and plug(s) loaded

static gboolean	default_downloader_plugin_id = 0;	// no default downloader
	
#include	"pixmaps/gsfdm.xpm"

// widget for the dlg, there just one so use static instead object_set_data
static GnomeDialog	*dlg = NULL;
static GtkWidget	*config_bp, *check_bp, *default_bp, *pix_w;
static GtkLabel	*name_l, *author_l;
static GtkLabel	*proto_l, *ext_l;
static GtkTooltips	*tips;
static GtkWidget	*tip_wid;

#define		PLUGIN_FIRST_ID 1

/************************************************************************/
//	functions definition
/************************************************************************/

/************************************************************************/
// first function : initialise the plugin support
// return false on error : e.i. exit
/************************************************************************/

/************************************************************************/
//	return a unique id for plugin
/************************************************************************/
static guint	gsfdm_plugin_get_new_id()
{
static	guint	id = PLUGIN_FIRST_ID;
	
	return( id++ );
}

/************************************************************************/
//	get a module def and load all data
/************************************************************************/
static gboolean gsfdm_load_module( GModule *module )
{
guint		index = 0, current_plug_id;
GPtrArray	*array = g_ptr_array_new();
gchar		*symbole;
gboolean	flag = FALSE;

	#ifdef GSFDM_DEBUG_PLUG_LOADING_PARSING
	g_print( "debug plug : parse symbole for %s\n", g_module_name( module ) );
	#endif
	
	// load table of symbol for this plug
	while( GsfdmPluginFunctionName[index] )
	{	if( !g_module_symbol( module, GsfdmPluginFunctionName[index], (gpointer *)&symbole ) )
		{	// enable to found symbol, cancel loading of this module
			flag = TRUE;
			break;
		}
						
		// add new prt
		g_ptr_array_add( array, (gpointer)symbole );
		index++;
	}
				
	// if problem when resolving loading of this module, abort loading
	if( flag )
	{	
		#ifdef GSFDM_DEBUG_PLUG_LOADING_PARSING
		g_print( "--- debug plug : error(s) resolving symbole\n");
		#endif

		g_ptr_array_free( array, FALSE );
		return( FALSE );			
	}
	
	// every things all right ( so far ), add to tables
	if( plug_init( array ) )
	{	gchar	*tmp, *name, **proto, **ext;
		guint	index, index2;
		
		current_plug_id = gsfdm_plugin_get_new_id();
		g_hash_table_insert( plugin_list, (gpointer)current_plug_id, (gpointer)module );
		g_hash_table_insert( plugin_enabled, (gpointer)current_plug_id, (gpointer)TRUE );
		g_hash_table_insert( plugin_func, (gpointer)current_plug_id, (gpointer)(array) );
		
		// load the proto list
		if( ( proto = plug_get_protocol_list( array ) ) )
		{	index = 0;
			while( proto[ index ] )
			{	
				// don't add type file: file: meen the plug know how to
				// extract streamed info from a file ( like asf )
				if( g_strcasecmp( proto[ index ], "file:" ) )
				{	tmp = g_strdup( proto[ index ] );
					g_strdown( tmp );
					g_hash_table_insert( plugin_proto, (gpointer)tmp, (gpointer)current_plug_id );
				}
				
				index++;
			}	
		}

		// load list of specific ext
		if( ( ext = plug_get_ext_list( array ) ) )
		{	index2 = 0;
		
			while( ext[ index2 ] )
			{	tmp = g_strdup( ext[ index2 ] );
				g_strdown( tmp );
				g_hash_table_insert( plugin_ext, (gpointer)tmp, (gpointer)current_plug_id );
				index2++;
			}
		}
		
		// and set the state, according to saved state, or default = TRUE
		gnome_config_push_prefix( "/"PACKAGE"/plug_state/" );
		name = gsfdm_file_get_file_name( g_module_name( module ) );
		tmp = g_strconcat( name, "=true", NULL );
		PLUG_SET_ENABLED( current_plug_id, (gpointer)gnome_config_get_bool_with_default( tmp, NULL ) );
		g_free( tmp );
		g_free( name );
		
		// act as default ???
		{	gchar	*tmp;
			
			gnome_config_pop_prefix();	
			gnome_config_push_prefix( "/"PACKAGE"/plug_def/" );
			tmp = gsfdm_file_get_file_name( g_module_name( module ) );
			if( !strcmp( gnome_config_get_string_with_default( "default=azerty", NULL ), tmp ) )
				default_downloader_plugin_id = current_plug_id;
	
			g_free( tmp );
			gnome_config_pop_prefix();	
		}
		return( TRUE );
	}		

	#ifdef GSFDM_DEBUG_PLUG_LOADING_PARSING
	g_print( "--- debug plug : ... invalid plug format unload\n");
	#endif
	
	// apparently, module initialization failed
	g_ptr_array_free( array, FALSE );
	return( FALSE );		
}

/************************************************************************/
//	the module loader....
/************************************************************************/
gboolean	gsfdm_plugin_init( void )
{
GList	*list, *list_tmp;
gchar	*tmp;
GModule	*module;
	
	if( !g_module_supported() )
	{	g_error( "NO SUPPORT FOUND FOR LOADABLE MODULE E.I. PLUGIN. ABORT\n" );
		return( FALSE );
	}
	
	// check and create user rep
	tmp = g_strconcat( g_get_home_dir(), PLUGIN_USER_PATH_TO_PLUG, NULL );
	if( gsfdm_file_get_file_type( tmp ) != GSFDM_FILE_TYPE_DIR )
		mkdir( tmp, S_IRWXU );
	g_free( tmp );

	
	// check for module and load : create struct
	plugin_list = g_hash_table_new( g_direct_hash, g_direct_equal );
	plugin_func = g_hash_table_new( g_direct_hash, g_direct_equal );
	plugin_enabled = g_hash_table_new( g_direct_hash, g_direct_equal );
	plugin_proto = g_hash_table_new( g_str_hash, g_str_equal );
	plugin_ext = g_hash_table_new( g_str_hash, g_str_equal );
	
	#ifdef GSFDM_DEBUG_PLUG_LOADING
	g_print( "debug plug : loading default plug...\n");
	#endif
	
	// first, load from default dir 
	if( ( list_tmp = list = gsfdm_file_get_file_from_dir( PLUGIN_DEFAULT_PATH_TO_PLUG ) ) )
	{	while( list )
		{	gchar	*ext, *path;
			
			if( !strcmp( ".so", ( ext = gsfdm_file_extract_ext( (gchar *)( list->data ) ) ) ) )
			{	path = g_strconcat( PLUGIN_DEFAULT_PATH_TO_PLUG, "/", (gchar *)( list->data ), NULL );
			
				// load this module and check ( cache ) all function needed
				if( ( module = g_module_open( path, 0 ) ) )
				{	if( !gsfdm_load_module( module ) )
						g_module_close( module );
				}
				#ifdef GSFDM_DEBUG_PLUG_LOADING
				else { g_print( "--- debug plug : %s not a plugin...\n", (gchar *)( list->data ) ); }
				#endif
			}
			
			g_free( ext );
			g_free( list->data );
			list = g_list_next( list );
		}
	
		g_list_free( list_tmp );
	}
	
	#ifdef GSFDM_DEBUG_PLUG_LOADING
	g_print( "debug plug : load user plug...\n");
	#endif
	
	// now in user dir
	tmp = g_strconcat( g_get_home_dir(), PLUGIN_USER_PATH_TO_PLUG, NULL );
	
	if( ( list_tmp = list = gsfdm_file_get_file_from_dir( tmp ) ) )
	{	while( list )
		{	gchar	*ext, *path;
			
			if( !strcmp( ".so", ( ext = gsfdm_file_extract_ext( (gchar *)( list->data ) ) ) ) )
			{	path = g_strconcat( tmp, "/", (gchar *)( list->data ), NULL );
			
				// load this module and check ( cache ) all function needed
				if( ( module = g_module_open( path, 0 ) ) )
				{	if( !gsfdm_load_module( module ) )
					g_module_close( module );
				}
					#ifdef GSFDM_DEBUG_PLUG_LOADING
					else {
					g_print( "--- debug plug : %s not a plugin...\n", (gchar *)( list->data ) ); }
					#endif
			}
			
			g_free( ext );
			g_free( list->data );
			list = g_list_next( list );
		}
	
		g_list_free( list_tmp );
	}
	g_free( tmp );
	
	// look if at least one plug registred
	if( !g_hash_table_size( plugin_list ) )
	{	g_error( "No plugin found neither in default dir nor in user dir, check and read the doc" );
		exit( 1 );
	}
	
	// there at least one module / plugin loaded
	plugin_initialized = TRUE;
	return( TRUE );
}

/************************************************************************/
//	stop all services provided by plugin : i.e. unload all plugin
//	if safe : ask plugin NOT to destroy job they're responsable of ( if plug support )
/************************************************************************/
void	gsfdm_plugin_stop( gboolean safe )
{
	static void local_save_callback( gpointer key, gpointer value, gpointer user_data )
	{	gchar	*n;
		
		n = gsfdm_file_get_file_name( g_module_name( PLUG_GET_MODULE( key ) ) );
		gnome_config_set_bool( n, (gboolean)value );
		
		g_free( n );
	}
	
	static void local_stop_callback( gpointer key, gpointer value, gpointer user_data )
	{	plug_stop( value, safe );
		// by the way, destroy the array
		g_ptr_array_free( (GPtrArray *)value, FALSE );
	}
	
	/************************************************************************/
	// save state
	if( !plugin_initialized ) return;
	
	gnome_config_push_prefix( "/"PACKAGE"/plug_state/" );
	g_hash_table_foreach( plugin_enabled, (GHFunc)local_save_callback, NULL );

	// save name of the default downloader
	gnome_config_pop_prefix();	
	gnome_config_push_prefix( "/"PACKAGE"/plug_def/" );

	if( default_downloader_plugin_id )
	{	gchar *name = gsfdm_file_get_file_name( g_module_name( PLUG_GET_MODULE( default_downloader_plugin_id ) ) );
			
			gnome_config_set_string( "default", name );
			g_free( name );
	} else
		gnome_config_clean_section( "default" );
	
	gnome_config_pop_prefix();	
	gnome_config_sync();

	// send "signal" to every plugin
	g_hash_table_foreach( plugin_func, (GHFunc)local_stop_callback, NULL );
	
	// clean all tables, even this is called just before exit...
	// for newbie : this func is responsable of stopping plug and don't care what could
	// happen after
	return;
	g_hash_table_destroy( plugin_list );
	g_hash_table_destroy( plugin_func );
	g_hash_table_destroy( plugin_enabled );
	g_hash_table_destroy( plugin_proto );
	g_hash_table_destroy( plugin_ext );
	plugin_initialized = FALSE;
}

/************************************************************************/
//	call a plug instruction : it's a kind of very primitive virtual code parser
/************************************************************************/
gpointer	gsfdm_plugin_call( guint plug_id, GsfdmPluginFunction func, ... )
{
va_list						arg;
st_gsfdm_url_entry_shared	*s;
st_gsfdm_config_proxy		*proxy;
	
	if( !plugin_initialized )
		gsfdm_plugin_init();
	
	// test if plug_id know : if removed and resume a connection there error
	if( !PLUG_GET_ENABLED( plug_id ) )
		return( NULL );

	switch( func )
	{	case PLUG_GET_NAME :
			return( (gpointer)plug_get_name( PLUG_GET_FUNC_ARRAY( plug_id ) ) );
		case PLUG_GET_VERSION :
			return( (gpointer)plug_get_version( PLUG_GET_FUNC_ARRAY( plug_id ) ) );
		case PLUG_GET_AUTHOR :
			return( (gpointer)plug_get_author( PLUG_GET_FUNC_ARRAY( plug_id ) ) );
		case PLUG_GET_ICON :
			return( (gpointer)plug_get_icon( PLUG_GET_FUNC_ARRAY( plug_id ) ) );
		case PLUG_GET_GSFDM_VERSION :
			return( (gpointer)plug_get_gsfdm_version( PLUG_GET_FUNC_ARRAY( plug_id ) ) );
		case PLUG_GET_COMMENT :
			return( (gpointer)plug_get_comment( PLUG_GET_FUNC_ARRAY( plug_id ) ) );
		case PLUG_GET_PROTOCOL_LIST :
			return( (gpointer)plug_get_protocol_list( PLUG_GET_FUNC_ARRAY( plug_id ) ) );
		case PLUG_GET_EXT_LIST :
			return( (gpointer)plug_get_ext_list( PLUG_GET_FUNC_ARRAY( plug_id ) ) );
		case PLUG_HAVE_GNOME_CONFIG :
			return( (gpointer)plug_have_gnome_config( PLUG_GET_FUNC_ARRAY( plug_id ) ) );
		case PLUG_GET_GNOME_DLG :
			return( (gpointer)plug_get_gnome_dlg( PLUG_GET_FUNC_ARRAY( plug_id ) ) );
		case PLUG_PARSE_FILE :
		{	FILE	*input, *output;
			gchar	*txt;
			
			va_start( arg, func );
			input = va_arg( arg, FILE * );
			output = va_arg( arg, FILE * );
			s = va_arg( arg, st_gsfdm_url_entry_shared * );
			txt = va_arg( arg, gchar * );
			va_end( arg );
		
			return( (gpointer)plug_parse_file( PLUG_GET_FUNC_ARRAY( plug_id ), input, output, s, txt ) );
		}
		case PLUG_START_JOB :
		{	va_start( arg, func );
			s = va_arg( arg, st_gsfdm_url_entry_shared * );
			proxy = va_arg( arg, st_gsfdm_config_proxy * );
			va_end( arg );
			return( (gpointer)plug_start_job( PLUG_GET_FUNC_ARRAY( plug_id ), s, proxy ) );
		}
		case PLUG_STOP_JOB :
		{	va_start( arg, func );
			s = va_arg( arg, st_gsfdm_url_entry_shared * );
			va_end( arg );
			return( (gpointer)plug_stop_job( PLUG_GET_FUNC_ARRAY( plug_id ), s ) );
		}
		case PLUG_UPDATE_JOB :
		{	va_start( arg, func );
			s = va_arg( arg, st_gsfdm_url_entry_shared * );
			va_end( arg );
			return( (gpointer)plug_update_job( PLUG_GET_FUNC_ARRAY( plug_id ), s ) );
		}
		default :
	}
	
	return( NULL );
}

/************************************************************************/
// return id of plugin that can download this url / file
// 0 if none
// if silent = TRUE, don't display a warning dlg in case of 0
/************************************************************************/
guint		gsfdm_plugin_get_id( gchar const *url, gboolean silent )
{
guint	id = 0;
gchar	*proto, *ext;
	
	if( !plugin_initialized )
		gsfdm_plugin_init();
	
	// look in proto ; with local file, there usually no proto
	if( ( proto = gsfdm_file_get_protocol( url ) ) )
	{	id = PLUG_GET_FROM_PROTO( proto );

		#ifdef GSFDM_DEBUG_PLUG_FOUND_PLUG
		g_print( "debug plugin - found for %s : (proto) %s %d\n", url, proto, id );
		#endif
		
		g_free( proto );
		if( id )
			return( id );
	}
	
	// in ext ; many file have no extension
	if( ( ext = gsfdm_file_extract_ext( url ) ) )
	{	id = PLUG_GET_FROM_EXT( ext );

		#ifdef GSFDM_DEBUG_PLUG_FOUND_PLUG
		g_print( "debug plugin - found for %s : (ext) %s %d\n", url, ext, id );
		#endif
			g_free( ext );
		if( id )
			return( id );
	}
	
	#ifdef GSFDM_DEBUG_PLUG_FOUND_PLUG
	g_print( "debug plugin - no match for %s\n", url );
	#endif
	
	// nothing, return default plug
	if( default_downloader_plugin_id )
		return( default_downloader_plugin_id );
	
	g_print("wwwwwwwwwwww\n");
	{	gchar	*tmp = g_strconcat( _( "Unknow of to Download : " ), url, NULL );
		
		gsfdm_message_push_message( tmp, TRUE, FALSE, TRUE );
		g_free( tmp );
	}
	
	// really nothing
	return( 0 );
}

/************************************************************************/
// this should be called before starting a connection to check
// whether this plug is enabled : TRUE
gboolean	gsfdm_plugin_check_for_plugin( guint plug_id )
{
	if( !plugin_initialized )
		gsfdm_plugin_init();

	return( PLUG_GET_ENABLED( plug_id ) );
}

/************************************************************************/
//	return name of each plug , glist->(g_new)(gchar*)
GList	*gsfdm_plug_get_list( void )
{
GList	*l = NULL;
	
	static void callback( gpointer key, gpointer value, gpointer data )
	{	l = g_list_append( l, (gpointer)g_strdup( plug_get_name( value ) ) );
	}
	
	/************************************************************************/
	if( !plugin_initialized )
		gsfdm_plugin_init();

	g_hash_table_foreach( plugin_func, (GHFunc)callback , NULL );
	return( g_list_first( l ) );
}

/************************************************************************/
//	return id for this plug or 0 if unknow : needed when loading
//	the list from saved session
guint	gsfdm_plugin_get_id_for_plugin( gchar const *plug_name )
{
guint	id = 0;
	
	static void local_scanning_callback( gpointer key, gpointer value, gpointer user_data)
	{	if( !strcmp( plug_name,plug_get_name( value ) ) )
				id = (guint)key;
	}
	
	/************************************************************************/
	if( !plugin_initialized )
		gsfdm_plugin_init();
	
	g_hash_table_foreach( plugin_func, (GHFunc)local_scanning_callback, NULL );
	return( id );
}

/************************************************************************/
// click on the button of the main option menu : set variable
static void select_main_menu( GtkWidget *w, gpointer key )
{
GPtrArray	*array;
gchar		*tmp, *tmp2, **a;
guint		i = 0;
gchar		**pix;
		
	#ifdef GSFDM_DEBUG_PLUG_CHANGE_PLUG
	g_print( "debug plug : fill info for plug %d \n", (guint)key );
	#endif
	
	gtk_object_set_data( GTK_OBJECT( dlg ), "current_id", key );
	
	// fix widgets
	array = PLUG_GET_FUNC_ARRAY( key );
	
	tmp = g_strconcat( plug_get_name( array ), " - Version ", plug_get_version( array ), NULL );
	gtk_label_set_text( name_l, tmp );
	g_free( tmp );
	
	// list of author
	a = plug_get_author( array );
	tmp = g_strdup( a[i] );
	while( i++, a[i] )
	{	tmp2 = g_strconcat( tmp, ", ", a[i], NULL );
		g_free( tmp );
		tmp = tmp2;
	}
	gtk_label_set_text( author_l, tmp );
	g_free( tmp );
	
	// add an icon ??
	if( !( pix = plug_get_icon( array ) ) ) 
		pix = gsfdm_xpm;
	gnome_pixmap_load_xpm_d( GNOME_PIXMAP( pix_w ), pix );
	
	// provide a config box ??
	if( plug_have_gnome_config( array ) )
		gtk_widget_set_sensitive( config_bp, TRUE );
	else
		gtk_widget_set_sensitive( config_bp, FALSE );

	// fill the protocol menu	
	tmp = g_strdup( "" );
	if( ( a = plug_get_protocol_list( array ) ) )			// just in case
	{	i = 0;
		while( a[i] )
		{	tmp2 = g_strconcat( tmp, ", ", a[i++], NULL );
			g_free( tmp );
			tmp = tmp2;
		}
	}
	gtk_label_set_text( proto_l, tmp );
	g_free( tmp );
	
	// fill the ext list
	tmp = g_strdup( "" );
	if( ( a = plug_get_ext_list( array ) ) )
	{	i = 0;
		while( a[i] )
		{	tmp2 = g_strconcat( tmp, ", ", a[i++], NULL );
			g_free( tmp );
			tmp = tmp2;
		}
	}
	gtk_label_set_text( ext_l, tmp );
	g_free( tmp );
	
	// fix the enabled widget
	// this is the default plug ???
	if( default_downloader_plugin_id == (guint)key )
	{	gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( default_bp ), TRUE );
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( check_bp ), TRUE );
		gtk_widget_set_sensitive( check_bp, FALSE );		// always true with default enabled
		PLUG_SET_ENABLED( key, TRUE );
		
		// if default switch from true to false, it set it at 0...
		default_downloader_plugin_id = (guint)key;
		// not really nice, but there simple and work fine

		#ifdef GSFDM_DEBUG_PLUG_CHANGE_PLUG
		g_print( "---- debug plug : fill info state will be - id %d - def_id %d - def  1 - enab 1 \n", (guint)key, default_downloader_plugin_id );
		#endif
		
	} else {
		gboolean val = PLUG_GET_ENABLED( key );
		guint def_id = default_downloader_plugin_id;
		
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( default_bp ), FALSE );
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( check_bp ), val );
		gtk_widget_set_sensitive( check_bp, TRUE );

		#ifdef GSFDM_DEBUG_PLUG_CHANGE_PLUG
		g_print( "---- debug plug : fill info state will be - id %d - def_id %d - def  0 - enab %d \n", (guint)key, default_downloader_plugin_id, val );
		#endif

		// this var is set also in callback - and could have been called - so make all things all right
		PLUG_SET_ENABLED( key, val );
		// if default switch from true to false, it set it at 0...
		default_downloader_plugin_id = def_id;
		// not really nice, but there simple and work fine
	}
	
	// set the tip with the comment
	gtk_tooltips_set_tip( tips, tip_wid, plug_get_comment( array ), plug_get_comment( array ) );
}

/************************************************************************/
static void  fill_main_menu( gpointer key, gpointer value, gpointer user_data )
{
GtkWidget	*w;

	#ifdef GSFDM_DEBUG_PLUG_DLG
	g_print( "debug plug : adding %d - %s - to main menu \n", (guint)key ,plug_get_name( value ));
	#endif
	
	w = gtk_menu_item_new_with_label( plug_get_name( value ) );
	gtk_signal_connect( GTK_OBJECT( w ), "activate", GTK_SIGNAL_FUNC( select_main_menu ), key );
	gtk_menu_append( GTK_MENU( user_data ), w );
}

/************************************************************************/
//	click on configure button
static void click_configure_callback( GtkWidget *bp, gpointer data )
{
	// if no widget, bp is desactived
	gtk_widget_show( plug_get_gnome_dlg( 
		PLUG_GET_FUNC_ARRAY( gtk_object_get_data( GTK_OBJECT( dlg ), "current_id" ) ) ) );
}

/************************************************************************/
// click on activate button
static void toggled_enabled_callback( GtkToggleButton *togglebutton, gpointer user_data )
{
guint	id = (guint)gtk_object_get_data( GTK_OBJECT( dlg ), "current_id" );
	
	#ifdef GSFDM_DEBUG_PLUG_DUMP_ENABLE_BP
	g_print( "debug plug : switch enable bp with %d - current is %d\n" ,id, gtk_toggle_button_get_active( togglebutton ) );
	#endif
	
	// receive signal before...
	PLUG_SET_ENABLED( id, gtk_toggle_button_get_active( togglebutton ) );
}

/************************************************************************/
// use this plug as default downloader
static void toggled_default_callback( GtkToggleButton *togglebutton, gpointer user_data )
{
	if( gtk_toggle_button_get_active( togglebutton ) )
	{	default_downloader_plugin_id = (guint)gtk_object_get_data( GTK_OBJECT( dlg ), "current_id" ); 
	
		#ifdef GSFDM_DEBUG_PLUG_DUMP_DEFAULT_BP
		g_print( "debug plug : switch default with %d\n",default_downloader_plugin_id );
		#endif
	
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( check_bp ), TRUE );
		gtk_widget_set_sensitive( check_bp, FALSE );
	}
	else {
		default_downloader_plugin_id = 0;				// no default plug
		gtk_widget_set_sensitive( check_bp, TRUE );
	}
}

/************************************************************************/
//	open the status dlg for plugin
/************************************************************************/
void	gsfdm_plugin_open_dlg( void )
{
GtkWidget	*f, *menu, *main_menu;
GtkBox		*b, *bv, *bh;
	
	if( !plugin_initialized )
		gsfdm_plugin_init();
	
	if( !dlg )
	{
		#ifdef GSFDM_DEBUG_PLUG_DLG
		g_print( "debug plug : realizing plugin dlg\n" );
		#endif
		
		dlg = GNOME_DIALOG( gnome_dialog_new( _( "Plug in information" ), GNOME_STOCK_BUTTON_OK, NULL ) );
			gnome_dialog_close_hides( dlg, TRUE );
			gnome_dialog_set_close( dlg, TRUE );
//			gnome_dialog_set_parent( dlg, GTK_WINDOW( win ) );
	
		gtk_box_set_spacing( GTK_BOX( dlg->vbox ), 5 );
		gtk_widget_set_usize( GTK_WIDGET( dlg ), 400, -1 );
		
		gtk_box_pack_start( GTK_BOX( dlg->vbox ), ( main_menu = gtk_option_menu_new() ), FALSE, FALSE, 5 );
		menu = gtk_menu_new();
		
		g_hash_table_foreach( plugin_func, (GHFunc)fill_main_menu , (gpointer)menu );
		gtk_option_menu_set_menu( GTK_OPTION_MENU( main_menu ), menu );
		
		#ifdef GSFDM_DEBUG_PLUG_DLG
		g_print( "--- debug plug : main menu filled... next steps\n" );
		#endif
		
		gtk_box_pack_start( GTK_BOX( dlg->vbox ), GTK_WIDGET( b = GTK_BOX( gtk_hbox_new( FALSE, 0 ) ) ), FALSE, FALSE, 5 );
		gtk_box_pack_start( b, ( check_bp = gtk_check_button_new_with_label( _( "Plugin is enabled" ) ) ), FALSE, FALSE, 0 );		
		gtk_signal_connect_after( GTK_OBJECT( check_bp ), "toggled", GTK_SIGNAL_FUNC( toggled_enabled_callback ), NULL );

		gtk_box_pack_start( GTK_BOX( dlg->vbox ), GTK_WIDGET( b = GTK_BOX( gtk_hbox_new( FALSE, 0 ) ) ), FALSE, FALSE, 5 );
		gtk_box_pack_start( b, ( default_bp = gtk_check_button_new_with_label( _( "Act as default downloader" ) ) ), FALSE, FALSE, 0 );		
		gtk_signal_connect_after( GTK_OBJECT( default_bp ), "toggled", GTK_SIGNAL_FUNC( toggled_default_callback ), NULL );

		gtk_box_pack_end( b, ( config_bp = gtk_button_new_with_label( _( "Configure" ) ) ), FALSE, FALSE, 0 );
		gtk_signal_connect( GTK_OBJECT( config_bp ), "clicked", GTK_SIGNAL_FUNC( click_configure_callback ), NULL );
		
		gtk_box_pack_start( GTK_BOX( dlg->vbox ), ( f = gtk_frame_new( _( "Plugin informations" ) ) ), TRUE, TRUE, 5 );
		gtk_container_add( GTK_CONTAINER( f ), GTK_WIDGET( b = GTK_BOX( gtk_vbox_new( FALSE, 5 ) ) ) ); 
		
		gtk_box_pack_start( GTK_BOX( b ), GTK_WIDGET( bh = GTK_BOX( gtk_hbox_new( FALSE, 0 ) ) ), FALSE, FALSE, 5 );
		
		gtk_box_pack_start( GTK_BOX( bh ), ( pix_w = gnome_pixmap_new_from_xpm_d( gsfdm_xpm ) ), FALSE, FALSE, 5 );
		tips = GTK_TOOLTIPS( gtk_tooltips_new() );
		tip_wid = pix_w;
		
		gtk_box_pack_start( GTK_BOX( bh ), gtk_vseparator_new(), FALSE, FALSE, 5 );
		gtk_box_pack_start( GTK_BOX( bh ), GTK_WIDGET( bv = GTK_BOX( gtk_vbox_new( FALSE, 0 ) ) ), FALSE, FALSE, 5 );

		gtk_box_pack_start( GTK_BOX( bv ), GTK_WIDGET( name_l = GTK_LABEL( gtk_label_new( _( "Name" ) ) ) ), TRUE, TRUE, 5 );
		gtk_box_pack_start( GTK_BOX( bv ), GTK_WIDGET( author_l = GTK_LABEL( gtk_label_new( _( "Author(s)" ) ) ) ), TRUE, TRUE, 5 );
		
		gtk_box_pack_start( GTK_BOX( b ), gtk_hseparator_new(), FALSE, FALSE, 5 );
				
		gtk_box_pack_start( GTK_BOX( b ), GTK_WIDGET( bh = GTK_BOX( gtk_hbox_new( FALSE, 0 ) ) ), FALSE, FALSE, 5 );
		gtk_box_pack_start( GTK_BOX( bh ), gtk_label_new( _( "Could Use Protocol(s) :" ) ), FALSE, FALSE, 5 );
		gtk_box_pack_start( GTK_BOX( bh ), GTK_WIDGET( proto_l = GTK_LABEL( gtk_label_new( "" ) ) ), FALSE, TRUE, 5 );
		
		gtk_box_pack_start( GTK_BOX( b ), GTK_WIDGET( bh = GTK_BOX( gtk_hbox_new( FALSE, 0 ) ) ), FALSE, FALSE, 5 );
		gtk_box_pack_start( GTK_BOX( bh ), gtk_label_new( _( "Could Parse Extension(s) :" ) ), FALSE, FALSE, 5 );
		gtk_box_pack_start( GTK_BOX( bh ), GTK_WIDGET( ext_l = GTK_LABEL( gtk_label_new( "" ) ) ), FALSE, TRUE, 5 );

		#ifdef GSFDM_DEBUG_PLUG_DLG
		g_print( "--- debug plug : filling with first plug info\n" );
		#endif
		gtk_option_menu_set_history( GTK_OPTION_MENU( main_menu ), 0 );
		// only problems with this dlg : apparently, set_history update corretly the label by
		// omit to send signal : should do it by miself, unfortunely i don't know wath item
		// is but a managed not to need it on callback
		select_main_menu( NULL, (gpointer)PLUGIN_FIRST_ID );

		gtk_widget_show_all( dlg->vbox );
	}
	
	#ifdef GSFDM_DEBUG_PLUG_DLG
	g_print( "debug plug : displaying dlg\n" );
	#endif
		
	gtk_widget_show( GTK_WIDGET( dlg ) );
}
