/************************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		Header for plugin operations

/************************************************************************/

#ifndef	GSFDM_PLUGIN
#define	GSFDM_PLUGIN

#include	<gnome.h>
#include	"gsfdm_url.h"

/************************************************************************/
//	some useful define to remember, put here just for not looking
//	everywhere further ( because i'm bound to forget where there're defined
/************************************************************************/
#define	PLUGIN_DEFAULT_PATH_TO_PLUG	"/usr/local/lib/gsfdm/plugin"
#define PLUGIN_USER_PATH_TO_PLUG "/gsfdm/plugin"

/************************************************************************/
//	structure and define definition
/************************************************************************/
#define	PLUG_FUNC_NB 15 
typedef enum {
		PLUG_INIT = 0,
		PLUG_STOP,
		PLUG_GET_NAME,
		PLUG_GET_VERSION,
		PLUG_GET_AUTHOR,
		PLUG_GET_ICON,
		PLUG_GET_GSFDM_VERSION,
		PLUG_GET_COMMENT,
		PLUG_GET_PROTOCOL_LIST,
		PLUG_GET_EXT_LIST,

		PLUG_HAVE_GNOME_CONFIG,
		PLUG_GET_GNOME_DLG,
		PLUG_PARSE_FILE,

		PLUG_START_JOB,
		PLUG_STOP_JOB,
		PLUG_UPDATE_JOB,
	
} GsfdmPluginFunction;

/************************************************************************/
//	functions definition
/************************************************************************/
// first function : initialise the plugin support
// return false on error : e.i. exit
gboolean	gsfdm_plugin_init( void );

/************************************************************************/
//	stop all services provided by plugin : i.e. unload all plugin
//	if safe : ask plugin NOT to destroy job they're responsable of ( if plug support )
void	gsfdm_plugin_stop( gboolean safe );

/************************************************************************/
//	call a plug instruction
gpointer	gsfdm_plugin_call( guint plug_id, GsfdmPluginFunction func, ... );

/************************************************************************/
// return id of plugin that can download this url / file
// 0 if none
// if silent = TRUE, don't display a warning dlg in case of 0
guint		gsfdm_plugin_get_id( gchar const *url, gboolean silent );

/************************************************************************/
// this should be called before starting a connection to check
// whether this plug is enabled : TRUE
gboolean	gsfdm_plugin_check_for_plugin( guint plug_id );

/************************************************************************/
//	return name of each plug , glist->(g_new)(gchar*)
GList	*gsfdm_plug_get_list( void );

/************************************************************************/
//	return id for this plug or 0 if unknow : needed when loading
//	the list from saved session
guint	gsfdm_plugin_get_id_for_plugin( gchar const *plug_name );


/************************************************************************/
//	open the status dlg for plugin
void	gsfdm_plugin_open_dlg( void );

#endif	GSFDM_PLUGIN
