/**********************************************************************/

//			Gsfdm : a gnome stream file downloader

//				E-mail : j.a.l @ free.fr

//		Header for main operations : main "gnome" window manipulation

/************************************************************************/

#include	<gnome.h>
#include	<libgnomeui/gnome-window-icon.h>
#include	<config.h>
#include	<unistd.h>
#include	<stdio.h>
#include	<ctype.h>
#include	<sys/stat.h>
#include	<signal.h>
#include	<libgnorba/gnorba.h>
#include	"main.h"
#include	"gsfdm_url.h"
#include	"gsfdm_info.h"
#include	"gsfdm_message.h"
#include	"gsfdm_config.h"
#include	"gsfdm_historic.h"
#include	"gsfdm_log.h"
#include	"gsfdm_fileop.h"
#include	"gsfdm_plugin.h"
#include	"GSFDM.h"

#define		GSFDM_APP_MAIN_NAME	"Gnome Stream Download File Manager version "VERSION
#define		GSFDM_APP_SCHEDULED_NAME GSFDM_APP_MAIN_NAME" - Exit Scheduled"

/************************************************************************/
//	debuging switches
/************************************************************************/
#ifdef HAVE_DEBUG
#define		DEBUG_EXIT_DLG
#define		DEBUG_SRC						// run from source dir...
#endif

/************************************************************************/
//	static function
/************************************************************************/
static void	gsfdm_open_file( void );		//**
static void	gsfdm_save_url_list( void );

static void	gsfdm_auto_dl( GtkWidget *widget );		// global auto dl

static void	gsfdm_config( void );			//**
static void	gsfdm_about( void );			//**
static void	gsfdm_exit( void );				//**

static void	gsfdm_log( void );				//**
static void gsfdm_plugin( void );

// ok, it' not really good, all there 2-3 lines functions but
// there better improvement to do
//	function that just wrap main dock and gtk functions, simplify the menu
static void gsfdm_dock_url( void );
static void gsfdm_dock_info( void );
static void gsfdm_dock_message( void );
static void	gsfdm_showhide_message( void );
static void	gsfdm_showhide_info( void );

static void gsfdm_main_save_config( void );

// corba stuff
static void CORBA_exception( CORBA_Environment *ev );

// no header when autogen the *impl.c file
GSFDM_Url 		impl_GSFDM_Url__create(PortableServer_POA poa, CORBA_Environment * ev);
GSFDM_Action	impl_GSFDM_Action__create(PortableServer_POA poa, CORBA_Environment * ev);

/************************************************************************/
// variables definitions
/************************************************************************/
// extern icon
#include	"pixmaps/showhide.xpm"
#include	"pixmaps/dock.xpm"

// popt option for command line parsing
static struct	poptOption popt_options[] =
{	{ "path",			'p', POPT_ARG_STRING, NULL, 'p', N_("Start in this directory"), "Static Path" },
	{ "quick_start",	'q', POPT_ARG_NONE, NULL, 'q', N_("Don't show the startup window during initialisation"), NULL },
	{ "no_resize",		'r', POPT_ARG_NONE, NULL, 'r', N_("Don't Restore Window(s) size"), NULL },
	{ NULL,				'\0', 0, NULL, 0 }
};

// data of main toolbar
static GnomeUIInfo	toolbar_data[] = {
  	GNOMEUIINFO_ITEM_STOCK( N_( "Open" ), N_( "Open a file" ),
   		&gsfdm_open_file, GNOME_STOCK_PIXMAP_OPEN ),
  	GNOMEUIINFO_ITEM_STOCK( N_( "Url" ), N_( "Directly add an Url" ),
   		&gsfdm_url_open_url, GNOME_STOCK_PIXMAP_NEW ),
	GNOMEUIINFO_SEPARATOR,
  	GNOMEUIINFO_ITEM_STOCK( N_( "Start" ), N_( "Start download of current entry(ies)" ),
   		&gsfdm_url_start, GNOME_STOCK_PIXMAP_EXEC ),
  	GNOMEUIINFO_ITEM_STOCK( N_( "Stop" ), N_( "Stop download of current entry(ies)" ),
   		&gsfdm_url_stop, GNOME_STOCK_PIXMAP_STOP ),
  	GNOMEUIINFO_ITEM_STOCK( N_( "Delete" ), N_( "Remove current entry(ies)" ),
   		&gsfdm_url_delete, GNOME_STOCK_PIXMAP_CLEAR ),
	GNOMEUIINFO_ITEM_STOCK( N_( "Auto" ), N_( "Switch auto download flag of entry(ies)" ),
   		&gsfdm_url_switch_auto_dl, GNOME_STOCK_PIXMAP_TIMER ),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_ITEM_STOCK( N_( "Config" ), N_( "Open the config / preferences dlg" ),
   		&gsfdm_config, GNOME_STOCK_PIXMAP_PREFERENCES ),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_HELP( "gsfdm" ),
	GNOMEUIINFO_ITEM_STOCK( N_( "About" ), N_( "About window" ),
		&gsfdm_about, GNOME_STOCK_PIXMAP_ABOUT ),
	GNOMEUIINFO_ITEM_STOCK( N_( "Exit" ), N_("Exit from G.S.F.D.M."),
		&gsfdm_exit, GNOME_STOCK_PIXMAP_EXIT ),
   GNOMEUIINFO_END
   };

static GnomeUIInfo file_menu[] = {
	GNOMEUIINFO_ITEM_STOCK( N_( "Open File / List" ), NULL, &gsfdm_open_file, GNOME_STOCK_PIXMAP_OPEN ),
	GNOMEUIINFO_ITEM_STOCK( N_( "Open URL" ), NULL, &gsfdm_url_open_url, GNOME_STOCK_PIXMAP_NEW ),
	GNOMEUIINFO_ITEM_STOCK( N_( "Save List" ), NULL, &gsfdm_save_url_list, GNOME_STOCK_PIXMAP_SAVE ),
	GNOMEUIINFO_MENU_EXIT_ITEM( gsfdm_exit, NULL ),
    GNOMEUIINFO_END
	};

static GnomeUIInfo download_menu[] = {
  	GNOMEUIINFO_ITEM_STOCK( N_( "Start" ), NULL, &gsfdm_url_start, GNOME_STOCK_PIXMAP_EXEC ),
  	GNOMEUIINFO_ITEM_STOCK( N_( "Stop" ), NULL,	&gsfdm_url_stop, GNOME_STOCK_PIXMAP_STOP ),
	GNOMEUIINFO_SEPARATOR,
  	GNOMEUIINFO_ITEM_STOCK( N_( "Initialize" ), NULL, &gsfdm_url_init, GNOME_STOCK_PIXMAP_CLEAR ),
  	GNOMEUIINFO_ITEM_STOCK( N_( "Restart" ), NULL,	&gsfdm_url_restart, GNOME_STOCK_PIXMAP_REFRESH ),
  	GNOMEUIINFO_ITEM_STOCK( N_( "Delete" ), NULL, &gsfdm_url_delete, GNOME_STOCK_PIXMAP_CLEAR ),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_TOGGLEITEM( N_( "Global Auto Download" ), NULL, &gsfdm_auto_dl, NULL ),
    GNOMEUIINFO_END
	};

#define GSFDM_MAIN_AUTO_DL_MENU_WIDGET download_menu[7].widget
	
static GnomeUIInfo edit_menu[] = {
	GNOMEUIINFO_MENU_COPY_ITEM( &gsfdm_url_copy_url_list, NULL ),
	GNOMEUIINFO_MENU_PASTE_ITEM( &gsfdm_url_paste_url_list, NULL ),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_MENU_CLEAR_ITEM( &gsfdm_url_clear_url_list, NULL ),
    GNOMEUIINFO_END
	};

static GnomeUIInfo view_url_submenu[] = {
	GNOMEUIINFO_ITEM( N_( "Un/Dock" ), NULL, &gsfdm_dock_url, dock_xpm ),
    GNOMEUIINFO_END
	};

static GnomeUIInfo view_info_submenu[] = {
	GNOMEUIINFO_ITEM( N_( "Un/Dock" ), NULL, &gsfdm_dock_info, dock_xpm ),
	GNOMEUIINFO_ITEM( N_( "Show / Hide" ), NULL, &gsfdm_showhide_info, showhide_xpm ),
    GNOMEUIINFO_END
	};

static GnomeUIInfo view_message_submenu[] = {
	GNOMEUIINFO_ITEM( N_( "Un/Dock" ), NULL, &gsfdm_dock_message, dock_xpm ),
	GNOMEUIINFO_ITEM( N_( "Show / Hide" ), NULL, &gsfdm_showhide_message, showhide_xpm ),
    GNOMEUIINFO_END
	};

static GnomeUIInfo view_menu[] = {
	GNOMEUIINFO_SUBTREE( N_( "Url list" ), view_url_submenu ),
	GNOMEUIINFO_SUBTREE( N_( "Info" ), view_info_submenu ),
	GNOMEUIINFO_SUBTREE( N_( "Messages" ), view_message_submenu ),
	GNOMEUIINFO_SEPARATOR,
	GNOMEUIINFO_ITEM_STOCK( N_( "Clear the List" ), NULL, &gsfdm_url_clear_url_list, GNOME_STOCK_PIXMAP_CLEAR ),
	GNOMEUIINFO_END
	};
	
static GnomeUIInfo log_menu[] = {
	GNOMEUIINFO_ITEM_STOCK( N_( "Log" ), NULL, &gsfdm_log, GNOME_STOCK_PIXMAP_SEARCH ),
	GNOMEUIINFO_ITEM_STOCK( N_( "History" ), NULL, &gsfdm_historic_open_historic, GNOME_STOCK_PIXMAP_TEXT_NUMBERED_LIST ),
    GNOMEUIINFO_END
	};

static GnomeUIInfo config_menu[] = {
	GNOMEUIINFO_MENU_PREFERENCES_ITEM( gsfdm_config, NULL ),
	GNOMEUIINFO_ITEM_STOCK( N_( "Plugin" ), NULL, &gsfdm_plugin, GNOME_STOCK_PIXMAP_LINE_IN ),	
    GNOMEUIINFO_END
	};
	
static GnomeUIInfo help_menu[] = {
	GNOMEUIINFO_HELP( "gsfdm" ),
	GNOMEUIINFO_ITEM_STOCK( N_( "About" ), NULL, &gsfdm_about, GNOME_STOCK_PIXMAP_ABOUT ),
    GNOMEUIINFO_END
	};
	
static GnomeUIInfo main_menu_data[] = {
	GNOMEUIINFO_MENU_FILE_TREE( file_menu ),
	GNOMEUIINFO_SUBTREE( N_( "Download" ), download_menu ),
	GNOMEUIINFO_MENU_EDIT_TREE( edit_menu ),
	GNOMEUIINFO_SUBTREE( N_( "View" ), view_menu ),
	GNOMEUIINFO_SUBTREE( N_( "Log / History" ), log_menu ),
	GNOMEUIINFO_MENU_SETTINGS_TREE( config_menu ),
	GNOMEUIINFO_MENU_HELP_TREE( help_menu ),
	GNOMEUIINFO_END
	};

// data for url, info and message widget, into the main app and in self-dlg mode
static GtkWidget	*url_list_frame, *info_frame, *message_frame;
static GtkWidget	*url_list_dock, *info_dock, *message_dock;
static GtkEventBox	*url_list_event, *info_event, *message_event;
static GtkWidget	*url_list_win, *info_win, *message_win;
static GtkEventBox	*url_list_win_event, *info_win_event, *message_win_event;
static gboolean		url_list_is_docked = TRUE, info_is_docked = TRUE, message_is_docked = TRUE;
static gboolean		url_list_is_show = TRUE, info_is_show = TRUE, message_is_show = TRUE;

// global variables
GnomeApp	*win;							// widget to top level window
GnomeAppBar	*status_bar;					// the status bar !

// default (true) is set when loading with default : false here
// because there only toggled signal, neither set nor unset...
gboolean	allow_auto_dl = FALSE;
	
GnomeDialog		*exit_dlg = NULL;

/************************************************************************/
// CORBA exeption functions
static void CORBA_exception( CORBA_Environment *ev )
{
    switch( ev->_major ) {
	case CORBA_SYSTEM_EXCEPTION:
	    g_log( "GSFDM", G_LOG_LEVEL_DEBUG, "CORBA system exception %s.\n", CORBA_exception_id( ev ) );
	    exit( 1 );
	case CORBA_USER_EXCEPTION:
	    g_log( "GSFDM", G_LOG_LEVEL_DEBUG, "CORBA user exception: %s.\n", CORBA_exception_id( ev ) );
	    exit( 1 );
	default:
	    break;
    }
}
	
/************************************************************************/
//	functions code
/************************************************************************/
int main( int argc, char *argv[] )
{
// popt option for command line parsing ; creating static here prevent parsing of value
static	gchar	*to_download = NULL;		// url to add 
static	gboolean	no_state = FALSE;		// don't restore previous ( graphics ) state ?
static struct	poptOption popt_options[] =
{	{ "download",		'p', POPT_ARG_STRING, &to_download, 'p', N_( "Download this url into the current dir" ), "url or file path" },
//	{ "quick_start",	'q', POPT_ARG_NONE, NULL, 'q', N_( "Don't show the startup window during initialisation" ), NULL },
	{ "no_state",		's', POPT_ARG_NONE, &no_state, 's', N_( "Don't restore the state of window" ), NULL },
	{ NULL,				'\0', 0, NULL, 0 }
};

//*********************************************************************//
GtkToolbar					*toolbar;
GtkBox						*vbox, *hbox;
gchar						*tmp;
CORBA_ORB					orb;
CORBA_Environment			ev;
PortableServer_POA			root_poa;
PortableServer_POAManager	pm;
GSFDM_Url					gsfdm_url_servant;
GSFDM_Action				gsfdm_action_servant;
//poptContext				popt_context;

	gtk_set_locale();
	bindtextdomain( PACKAGE, PACKAGE_LOCALE_DIR );
	textdomain( PACKAGE );

	// initialize
	CORBA_exception_init( &ev );
	orb = gnome_CORBA_init_with_popt_table( PACKAGE, VERSION, &argc, argv,
        popt_options, 0, NULL, GNORBA_INIT_SERVER_FUNC, &ev );
	CORBA_exception( &ev );

	// parse data and send to current corba running server

	// Register the CORBA object : server side
	root_poa = ( PortableServer_POA )CORBA_ORB_resolve_initial_references( orb, "RootPOA", &ev );
	CORBA_exception( &ev );
	pm = PortableServer_POA__get_the_POAManager( root_poa, &ev );
	CORBA_exception( &ev );
	PortableServer_POAManager_activate( pm, &ev );
	CORBA_exception( &ev );

	// look whether server gsfdm_url already running : in case connect to it and send data
	// there bound to have other solution but this one is not too bad...
	{	GoadServerList *l = goad_server_list_get();
		
		if( ( gsfdm_url_servant = goad_server_activate_with_id( l, "gsfdm_url", GOAD_ACTIVATE_EXISTING_ONLY, NULL ) ) )
		{	// ok, running
			if( to_download )
			{	GSFDM_Url_add_url( gsfdm_url_servant, to_download, &ev );
			}else {
				// in fact gdialog don't care about weight and height
				system_ext( "gdialog --infobox \"GSFDM Server Already running...\" 100 100 &", FALSE );
			}
			
			goad_server_list_free( l );
			exit( 0 );
		}

		goad_server_list_free( l );
	}

	// no server running, add a new one...		
	gsfdm_url_servant = impl_GSFDM_Url__create( root_poa, &ev );
	CORBA_exception( &ev );	
	goad_server_register( CORBA_OBJECT_NIL, gsfdm_url_servant, "gsfdm_url", "object", &ev );
	CORBA_exception( &ev );
	
	gsfdm_action_servant = impl_GSFDM_Action__create( root_poa, &ev );
	CORBA_exception( &ev );
	goad_server_register( CORBA_OBJECT_NIL, gsfdm_action_servant, "gsfdm_action", "object", &ev );
	CORBA_exception( &ev );

	#ifdef DEBUG_SRC
		gnome_window_icon_set_default_from_file( PACKAGE_SOURCE_DIR"/pixmaps/gsfdm.xpm" );
	#else
		gnome_window_icon_set_default_from_file( PACKAGE_ICON_DIR"/gsfdm.xpm" );
	#endif

// check and create user rep
	tmp = g_strconcat( g_get_home_dir(), "/gsfdm", NULL );
	if( gsfdm_file_get_file_type( tmp ) != GSFDM_FILE_TYPE_DIR )
		mkdir( tmp, S_IRWXU );
	g_free( tmp );

  	// create the top window
	win = GNOME_APP( gnome_app_new( PACKAGE, GSFDM_APP_MAIN_NAME ) );
	
	// fill the main window with the two container box
	gnome_app_set_contents( win, GTK_WIDGET( vbox = GTK_BOX( gtk_vbox_new( FALSE, 5 ) ) ) );
//	gtk_container_set_border_width( GTK_CONTAINER( vbox ), 5 );

	gtk_box_pack_start( vbox, GTK_WIDGET( hbox = GTK_BOX( gtk_hbox_new( FALSE, 5 ) ) ), TRUE, TRUE, 5 );
//	gtk_container_set_border_width( GTK_CONTAINER( hbox ), 5 );

	//*********************************************************************//
	// add the 3 mains parts as dockable item, use eventbox to allow dock, undock on 'flight'
	//*********************************************************************//
	// the url_list widget
	gtk_container_add( GTK_CONTAINER( url_list_frame = gtk_frame_new( _( "URL List" ) ) ), 
		GTK_WIDGET( url_list_event = GTK_EVENT_BOX( gtk_event_box_new() ) ) );
	gtk_container_add( GTK_CONTAINER( url_list_event ), ( url_list_dock = gsfdm_url_get_dock() ) );
	gtk_container_set_border_width( GTK_CONTAINER( url_list_frame ), 5 );
	gtk_container_set_border_width( GTK_CONTAINER( url_list_event ), 5 );
	gtk_box_pack_start( hbox, GTK_WIDGET( url_list_frame ), TRUE, TRUE, 0 );

	// the downloading info widget
	gtk_container_add( GTK_CONTAINER( info_frame = gtk_frame_new( _( "Downloading informations" ) ) ), 
		GTK_WIDGET( info_event = GTK_EVENT_BOX( gtk_event_box_new() ) ) );
	gtk_container_add( GTK_CONTAINER( info_event ), ( info_dock = gsfdm_info_get_dock() ) );
	gtk_container_set_border_width( GTK_CONTAINER( info_frame ), 5 );
	gtk_container_set_border_width( GTK_CONTAINER( info_event ), 5 );
	gtk_box_pack_start( hbox, GTK_WIDGET( info_frame ), FALSE, FALSE, 0 );

	// the message widget
	gtk_container_add( GTK_CONTAINER( message_frame = gtk_frame_new( _( "Messages, Informations" ) ) ), 
		GTK_WIDGET( message_event = GTK_EVENT_BOX( gtk_event_box_new() ) ) );
	gtk_container_add( GTK_CONTAINER( message_event ), ( message_dock = gsfdm_message_get_dock() ) );
	gtk_container_set_border_width( GTK_CONTAINER( message_frame ), 5 );
	gtk_container_set_border_width( GTK_CONTAINER( message_event ), 5 );
	gtk_box_pack_start( vbox, GTK_WIDGET( message_frame ), FALSE, FALSE, 0 );

	//*********************************************************************//
	//	add all common gnome app stuff : toolbar, menu, status bar
	//*********************************************************************//
	// add the main toobar
	toolbar = GTK_TOOLBAR( gtk_toolbar_new( GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_ICONS ) );
	gtk_toolbar_set_space_size( toolbar, 0 );
	gtk_container_set_border_width( GTK_CONTAINER( toolbar ), 0 );
	gnome_app_fill_toolbar( toolbar, toolbar_data, NULL );
	gnome_app_set_toolbar( win, (GtkToolbar *)toolbar );

	// add the menu bar
    gnome_app_create_menus( win, main_menu_data );
	
	// add the status bar
	status_bar = GNOME_APPBAR( gnome_appbar_new( FALSE, TRUE,GNOME_PREFERENCES_NEVER ) );
	gnome_app_set_statusbar( win, GTK_WIDGET( status_bar ) );
	
	// add main events
    gtk_signal_connect( GTK_OBJECT( win ), "delete_event", GTK_SIGNAL_FUNC( gsfdm_exit ), NULL );

	//*********************************************************************//
	// create the window(s) for dock when undocked
	//*********************************************************************//
	// for the url list dock
	url_list_win = gtk_window_new( GTK_WINDOW_TOPLEVEL );
	gtk_widget_ref( url_list_win );
	gtk_window_set_title( GTK_WINDOW( url_list_win ), _( "GSFDM Url list" ) );
    gtk_signal_connect_object( GTK_OBJECT( url_list_win ), "delete_event",
		GTK_SIGNAL_FUNC( gsfdm_main_dock_op ), (GtkObject *)MAIN_DOCK_URL_LIST );	// you don't like ??? really ??
	url_list_win_event = GTK_EVENT_BOX( gtk_event_box_new() );
//	gtk_widget_ref( event );
	gtk_container_add( GTK_CONTAINER( url_list_win ), GTK_WIDGET( url_list_win_event ) );
	gtk_container_set_border_width( GTK_CONTAINER( url_list_win ), 5 );
	gtk_widget_show( GTK_WIDGET( url_list_win_event ) );

	// one for the dowloading information
	info_win = gtk_window_new( GTK_WINDOW_TOPLEVEL );
	gtk_widget_ref( info_win );
	gtk_window_set_policy( GTK_WINDOW( info_win ), TRUE, FALSE, TRUE );
	gtk_window_set_title( GTK_WINDOW( info_win ), _( "GSFDM Downloading Informations" ) );
    gtk_signal_connect_object( GTK_OBJECT( info_win ), "delete_event", 
		GTK_SIGNAL_FUNC( gsfdm_main_dock_op ), (GtkObject *)MAIN_DOCK_INFO );
	info_win_event = GTK_EVENT_BOX( gtk_event_box_new() );
//	gtk_widget_ref( event );
	gtk_container_add( GTK_CONTAINER( info_win ), GTK_WIDGET( info_win_event ) );
	gtk_container_set_border_width( GTK_CONTAINER( info_win ), 5 );
	gtk_widget_show( GTK_WIDGET( info_win_event ) );

	// and for the message dock
	message_win = gtk_window_new( GTK_WINDOW_TOPLEVEL );
	gtk_widget_ref( message_win );
	gtk_window_set_title( GTK_WINDOW( message_win ), _( "GSFDM Message(s)" ) );
    gtk_signal_connect_object( GTK_OBJECT( message_win ), "delete_event", 
		GTK_SIGNAL_FUNC( gsfdm_main_dock_op ), (GtkObject *)MAIN_DOCK_MESSAGE );
	message_win_event = GTK_EVENT_BOX( gtk_event_box_new() );
//	gtk_widget_ref( event );
	gtk_container_add( GTK_CONTAINER( message_win ), GTK_WIDGET( message_win_event ) );
	gtk_container_set_border_width( GTK_CONTAINER( message_win ), 5 );
	gtk_widget_show( GTK_WIDGET( message_win_event ) );

	gtk_window_set_policy( GTK_WINDOW( win ), TRUE, TRUE, TRUE );
 	gtk_widget_show_all( GTK_WIDGET( win ) );

	// restore the state and size of previous session
	if( !no_state )
	{	gchar	*geometry;
		gint	w,h,x,y;

		gnome_config_push_prefix( "/"PACKAGE"/display/" );

		// maybe undock window
		if( !gnome_config_get_bool_with_default( "url_list_is_docked=true", NULL ) )
			gsfdm_main_dock_op( MAIN_DOCK_URL_LIST );
		if( !gnome_config_get_bool_with_default( "info_is_docked=true", NULL ) )
			gsfdm_main_dock_op( MAIN_DOCK_INFO );
		if( !gnome_config_get_bool_with_default( "message_is_docked=true", NULL ) )
			gsfdm_main_dock_op( MAIN_DOCK_MESSAGE );

		// and hide sone
		if( !gnome_config_get_bool_with_default( "info_is_show=true",NULL ) )
			gsfdm_main_showhide_op( MAIN_DOCK_INFO );
		if( !gnome_config_get_bool_with_default( "message_is_show=true",NULL ) )
			gsfdm_main_showhide_op( MAIN_DOCK_MESSAGE );	

		// now take care about windows size
		gnome_parse_geometry( ( geometry = gnome_config_get_string( "geometry=700x600" ) ), &x, &y, &w, &h );	
		gtk_widget_set_uposition( GTK_WIDGET( win ), x, y );
		gtk_window_set_default_size( GTK_WINDOW( win ), w, h );
		g_free( geometry );
		
		if( ( geometry = gnome_config_get_string( "url_list_geometry" ) ) )
		{	gnome_parse_geometry( geometry, &x, &y, &w, &h );
			gtk_window_set_default_size( GTK_WINDOW( url_list_win ), w, h );
			gtk_window_set_position( GTK_WINDOW( url_list_win ), GTK_WIN_POS_NONE );
			g_free( geometry );
		}
				
		if( ( geometry = gnome_config_get_string( "message_geometry" ) ) )
		{	gnome_parse_geometry( geometry, &x, &y, &w, &h );
			gtk_window_set_default_size( GTK_WINDOW( message_win ), w, h );
			gtk_window_set_position( GTK_WINDOW( url_list_win ), GTK_WIN_POS_NONE );
			g_free( geometry );
		}
		
		gnome_config_pop_prefix();
	}

	gsfdm_message_push_code( MESS_BEGIN, NULL );
	
	// main config, very fast to do....
	gnome_config_push_prefix( "/"PACKAGE"/main/" );
	// created at false... 
	if( gnome_config_get_bool_with_default( "allow_auto_dl=true", NULL ) )
//	    gtk_check_menu_item_toggled( GTK_CHECK_MENU_ITEM( GSFDM_MAIN_AUTO_DL_MENU_WIDGET ) );
	    gtk_check_menu_item_set_active( GTK_CHECK_MENU_ITEM( GSFDM_MAIN_AUTO_DL_MENU_WIDGET ), 1 );
	gnome_config_pop_prefix();

	// init and load config, the module list, init url autodownlader
	// all must be loader in this order
	gsfdm_config_load();
	gsfdm_historic_load_conf();
	gsfdm_log_init();
	gsfdm_plugin_init();
	gsfdm_url_load_config();

	gtk_main();
	
	return( 0 );
}

// *****************************************************************************
gboolean	gsfdm_main_dock_op( MainDockItem item  )
{
GtkWidget	*frame, *w, *dock;
GtkEventBox	*event, *we;
gboolean	*dock_state, *show_state;
		
	// get the widget from type of window,
	// with more dockable window must use a table / struct...
	switch( item )
	{	case MAIN_DOCK_URL_LIST :
			w = url_list_win,
			we = url_list_win_event;
			frame = url_list_frame;
			event = url_list_event;
			dock = url_list_dock;
			dock_state  = &url_list_is_docked;
			show_state  = &url_list_is_show;
			break;
		case MAIN_DOCK_INFO :
			w = info_win;
			we = info_win_event;
			frame = info_frame;
			event = info_event;
			dock = info_dock;
			dock_state  = &info_is_docked;
			show_state  = &info_is_show;
			break;
		case MAIN_DOCK_MESSAGE :
			w = message_win;
			we = message_win_event;
			frame = message_frame;
			event = message_event;
			dock = message_dock;
			dock_state  = &message_is_docked;
			show_state  = &message_is_show;
			break;
		default :
			return( FALSE );
	}
	
	// now perform dock or undock
	if( *dock_state )
	{	// undock
		gtk_widget_hide( dock );
		gtk_container_remove( GTK_CONTAINER( event ), dock );
		gtk_container_add( GTK_CONTAINER( we ), dock );
		gtk_widget_hide( frame );				// shrink the main window
	
		if( GTK_WIDGET_REALIZED( w ) )
		{	gtk_widget_show( dock );
			gtk_widget_show( w );
		} else {
			gtk_widget_show_all( w );
		}

		*dock_state = FALSE;
		*show_state = TRUE;
	} else {
		// dock and hide window
		gtk_widget_hide( w );
		gtk_widget_hide( dock );
		gtk_container_remove( GTK_CONTAINER( we ), dock );
		gtk_container_add( GTK_CONTAINER( event ), dock );
		gtk_widget_show( dock );
		gtk_widget_show( frame );				// docked show the contianer frame
		
		*dock_state = TRUE;
	}

	*show_state = TRUE;							// alwazys display the widget
	return( TRUE );
}

/************************************************************************/
gboolean	gsfdm_main_showhide_op( MainDockItem item  )
{
GtkWidget	*frame, *w, *dock;
GtkEventBox	*event, *we;
gboolean	*dock_state, *show_state;

	// get the widget from type of window,
	// with more dockable window must use a table / struct...
	switch( item )
	{	case MAIN_DOCK_URL_LIST :
			w = url_list_win,
			we = url_list_win_event;
			frame = url_list_frame;
			event = url_list_event;
			dock = url_list_dock;
			dock_state  = &url_list_is_docked;
			show_state  = &url_list_is_show;
			break;
		case MAIN_DOCK_INFO :
			w = info_win;
			we = info_win_event;
			frame = info_frame;
			event = info_event;
			dock = info_dock;
			dock_state  = &info_is_docked;
			show_state  = &info_is_show;
			break;
		case MAIN_DOCK_MESSAGE :
			w = message_win;
			we = message_win_event;
			frame = message_frame;
			event = message_event;
			dock = message_dock;
			dock_state  = &message_is_docked;
			show_state  = &message_is_show;
			break;
		default :
			return( FALSE );
	}
	
	if( *show_state )
	{	//	now hide, hide both window and frame
		gtk_widget_hide( w );
		gtk_widget_hide( frame );
	
		*show_state = FALSE;
		
	} else {
		// show, in frame if docked, or in window
		if( *dock_state )
		{	// in dock, show the frame
			gtk_widget_show( frame );
		} else {
			// independant window
			gtk_widget_show( w );				// that all, already realized...
		}
		
		*show_state = TRUE;
	}
	
	return( TRUE );
}

/************************************************************************/
// inform on the dock state of a sub dock
/************************************************************************/
gboolean	gsfdm_main_dock_op_get_dock_state( MainDockItem item )
{
	switch( item )
	{	case MAIN_DOCK_URL_LIST :
			return( url_list_is_docked );
			break;
		case MAIN_DOCK_INFO :
			return( info_is_docked );
			break;
		case MAIN_DOCK_MESSAGE :
			return( message_is_docked );	
			break;
		default :
			return( FALSE );
	}
}

/************************************************************************/
// inform on the dock state of a sub dock
/************************************************************************/
gboolean	gsfdm_main_dock_op_get_hide_state( MainDockItem item )
{
	switch( item )
	{	case MAIN_DOCK_URL_LIST :
			return( url_list_is_show );
			break;
		case MAIN_DOCK_INFO :
			return( info_is_show );
			break;
		case MAIN_DOCK_MESSAGE :
			return( message_is_show );	
			break;
		default :
			return( FALSE );
	}
}

// **********************************************************************/
//	save current "main" configuration
// **********************************************************************/
static void gsfdm_main_save_config( void )
{
gchar	*geometry;

	// save here the state of each dockable window, this is a global option
	gnome_config_push_prefix( "/"PACKAGE"/display/" );
	gnome_config_set_bool( "url_list_is_docked", url_list_is_docked );
	gnome_config_set_bool( "info_is_docked", info_is_docked );
	gnome_config_set_bool( "message_is_docked", message_is_docked );
	gnome_config_set_bool( "info_is_show", info_is_show );
	gnome_config_set_bool( "message_is_show", message_is_show );

	geometry = gnome_geometry_string( GTK_WIDGET( win )->window );
    gnome_config_set_string( "geometry", geometry );
    g_free( geometry );
	if( GTK_WIDGET_REALIZED( url_list_win  ) )
	{	geometry = gnome_geometry_string( GTK_WIDGET( url_list_win )->window );
    	gnome_config_set_string( "url_list_geometry", geometry );
    	g_free( geometry );
	}

	// nota : the info window isn't sizable
	
	if( GTK_WIDGET_REALIZED( message_win  ) )
	{	geometry = gnome_geometry_string( GTK_WIDGET( message_win )->window );
    	gnome_config_set_string( "message_geometry", geometry );
    	g_free( geometry );
	}

	gnome_config_pop_prefix();
	
	// save the state of auto dl flag
	gnome_config_push_prefix( "/"PACKAGE"/main/" );
	gnome_config_set_bool( "allow_auto_dl", allow_auto_dl );
	gnome_config_pop_prefix();

	gnome_config_sync();
}

// **********************************************************************/
// **********************************************************************/
gboolean	gsfdm_main_get_allow_auto_dl( void )
{	return( allow_auto_dl );
}

// **********************************************************************/
// callback when request for exit
/************************************************************************/
static	gboolean		exit_valided = FALSE;	// don't take care of there codes ???
												// or requested a scheduled exit ???

/************************************************************************/
// simply the real exit function that save all data, according to configuration
// in this point there no more donwloading in progress, or there to be killed
// the job is	save ALL config
//				unload plug
//				perhaps stop pppd
//				perhaps stop host
static void gsfdm_main_real_exit( MainExitMode exit_code )
{
	// there simply nothing more to do but user haven't requested an exit yet
	if( !exit_valided )
		return;
	
	// write that we exit
	gsfdm_message_push_code( MESS_EXIT, NULL );
	
	// save config...
	gsfdm_main_save_config();
	gsfdm_config_save();									// save configuration
	gsfdm_historic_save_conf();
	gsfdm_log_save_config();
	gsfdm_url_save_config();
	
	// now perform the exit type
	switch( exit_code )
	{
		case MAIN_EXIT_ANYWAY :								// save all, ask "url" to stop all process
			gsfdm_url_stop_downloading();
			gsfdm_plugin_stop( FALSE );						// kill remaining
			break;
		
		case MAIN_EXIT_SHUTDOWN_PPPD :						// ... and close ( try to ) the pppd connextion / demon
		{	gchar	*tmp = g_strconcat( "/var/run/", gsfdm_config_get_pppd(), ".pid", NULL );
			pid_t	pid;
			FILE	*stream;
			
			// save config, stop plugin and close remain transfert ( it does ?? )
			gsfdm_url_stop_downloading();
			gsfdm_plugin_stop( FALSE );	
			
			// get pid of pppd to close from lock file
			if( ( stream = fopen( tmp, "r" ) ) )
			{	fscanf( stream, "%d", &pid );
				fclose( stream );
				kill( pid, SIGINT );
			}
			
			g_free( tmp );
			break;
		}
		
		case MAIN_EXIT_SHUTDOWN_HOST :							// ... and stop the host ( just root user... )
			// stop pppd
		{	gchar	*tmp = g_strconcat( "/var/run/", gsfdm_config_get_pppd(), ".pid", NULL );
			pid_t	pid;
			FILE	*stream;
			
			// save config, stop plugin and close remain transfert ( it does ?? )
			gsfdm_url_stop_downloading();
			gsfdm_plugin_stop( FALSE );	
			
			// get pid of pppd to close from lock file
			if( ( stream = fopen( tmp, "r" ) ) )
			{	fscanf( stream, "%d", &pid );
				fclose( stream );
				kill( pid, SIGINT );
			}
			
			g_free( tmp );
			
			// delay 10s shutdown of system
			system_ext( "shutdown -ah \"now\" \"Automatic shutdown from GSFDM\"", TRUE );
			break;
		}
		case MAIN_EXIT_BACKGROUND :							// close but let current child running
			gsfdm_plugin_stop( TRUE );
		default :
	}
	
	gtk_main_quit();								// quit now
}

/************************************************************************/
//	this is an internal callback, telling that the "url" block has no more job to 
// perform ---> warm user ( if configurated ) or close
void	gfsdm_main_job_stack_empty( void )
{
	// if user scheduled and exit, exit, don't try to warm him for an empty job stack
	if( exit_valided && exit_dlg )
	{	gsfdm_main_real_exit( (MainExitMode)gtk_object_get_data( GTK_OBJECT( exit_dlg ), "code" ) );
		return;
	}
	
	// when to be warmed about this state ???
	if( gsfdm_config_get_warm_emply_job() )
		gtk_widget_show( gnome_warning_dialog_parented( _( "GSFDM Job Stack Empty" ), GTK_WINDOW( win ) ) );
		
	// nothing more
}

/************************************************************************/
// called by callback of ok, radio and check bp.. would not like to freeze main app
// during the selection "session"
static void gsfdm_exit_ok_callback( GtkWidget *dlg )
{
	#ifdef	DEBUG_EXIT_DLG
	printf( "debug main : enter exit session with code %d - %d\n", (MainExitMode)gtk_object_get_data( GTK_OBJECT( dlg ), "code" ), 
		gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( gtk_object_get_data( GTK_OBJECT( dlg ), "download_widget" ) ) ) );
	#endif
	
	exit_valided = TRUE;							// ok schedule exit
	gtk_window_set_title( GTK_WINDOW( win ), GSFDM_APP_SCHEDULED_NAME );
	
	// infor message and perhaps stop auto downloading	

	allow_auto_dl = gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( gtk_object_get_data( GTK_OBJECT( dlg ), "download_widget" ) ) );
/*	
	// register a date limit for 
	if( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( gtk_object_get_data( GTK_OBJECT( dlg ), "date_check_widget" ) ) ) )
	{	// yes...
		time_t	t = gnome_date_edit_get_date( (GnomeDateEdit *)gtk_object_get_data( GTK_OBJECT( dlg ), "date_widget" ) );
		gchar	*command;
		//echo "wterm" | at 23:58

		command = g_strdup_printf( 	"echo at " );
		system_ext( command, FALSE );
		g_free( command );
	}
*/	
	// set the mode
	if( (MainExitMode)gtk_object_get_data( GTK_OBJECT( dlg ), "code" ) == MAIN_EXIT_ANYWAY )
	{	// direct exit
		allow_auto_dl = FALSE;
		gsfdm_main_real_exit( MAIN_EXIT_ANYWAY );
		return;
	}

	gtk_check_menu_item_set_active( GTK_CHECK_MENU_ITEM( GSFDM_MAIN_AUTO_DL_MENU_WIDGET ), allow_auto_dl );	
}

/************************************************************************/
static void gsfdm_exit_radio_callback( GtkToggleButton *togglebutton, gpointer data )
{	if( togglebutton->active )
		gtk_object_set_data( GTK_OBJECT( data ), "code", gtk_object_get_data( GTK_OBJECT( togglebutton ), "code" ) );
}

/************************************************************************/
// open the exit mode selection dlg or simply switch to real_exit
static void	gsfdm_exit( void )
{
GtkRadioButton	*exit_radio;
GtkWidget		*wid;
	
	// if there job(s) running, ask what to do
	#ifdef DEBUG_EXIT_DLG
	if( TRUE )
	#else
	if( gsfdm_url_nb_are_working() )
	#endif
	{	if( !exit_dlg )										// create the dialog first
		{	exit_dlg = GNOME_DIALOG( gnome_dialog_new( _( "Exit" ), 
				GNOME_STOCK_BUTTON_OK, GNOME_STOCK_BUTTON_CANCEL, NULL ) );
			gnome_dialog_close_hides( exit_dlg, TRUE );
			gnome_dialog_set_close( exit_dlg, TRUE );
			gnome_dialog_set_parent( exit_dlg, GTK_WINDOW( win ) );
			
			gnome_dialog_button_connect_object( exit_dlg, 0, GTK_SIGNAL_FUNC( gsfdm_exit_ok_callback ), GTK_OBJECT( exit_dlg ) );
			gnome_dialog_button_connect_object( exit_dlg, 1, GTK_SIGNAL_FUNC( gtk_widget_hide ), GTK_OBJECT( exit_dlg ) );
			gtk_box_set_spacing( GTK_BOX( exit_dlg->vbox ), 5 );
			
			gtk_box_pack_start( GTK_BOX( exit_dlg->vbox ), gtk_label_new( _( "Some file(s) are running" ) ), FALSE, FALSE, 5 );
						
			// the radio part
			gtk_box_pack_start( GTK_BOX( exit_dlg->vbox ), GTK_WIDGET( exit_radio = GTK_RADIO_BUTTON( 
				gtk_radio_button_new_with_label( NULL, _( "Exit Anyway ( and kill )" ) ) ) ), FALSE, FALSE, 5 );
			gtk_object_set_data( GTK_OBJECT( exit_radio ), "code", (gpointer)MAIN_EXIT_ANYWAY );
			gtk_signal_connect( GTK_OBJECT( exit_radio ) , "toggled", GTK_SIGNAL_FUNC( gsfdm_exit_radio_callback ), (gpointer)exit_dlg );

			gtk_box_pack_start( GTK_BOX( exit_dlg->vbox ), GTK_WIDGET( exit_radio = GTK_RADIO_BUTTON( 
				gtk_radio_button_new_with_label( gtk_radio_button_group( exit_radio ), 
				_( "Push job(s) in background" ) ) ) ), FALSE, FALSE, 5 );
			gtk_object_set_data( GTK_OBJECT( exit_radio ), "code", (gpointer)MAIN_EXIT_BACKGROUND );
			gtk_signal_connect( GTK_OBJECT( exit_radio ) , "toggled", GTK_SIGNAL_FUNC( gsfdm_exit_radio_callback ), (gpointer)exit_dlg );

			gtk_box_pack_start( GTK_BOX( exit_dlg->vbox ), GTK_WIDGET( exit_radio = GTK_RADIO_BUTTON( 
				gtk_radio_button_new_with_label( gtk_radio_button_group( exit_radio ), 
				_( "Exit when there no more job" ) ) ) ), FALSE, FALSE, 5 );
			gtk_object_set_data( GTK_OBJECT( exit_radio ), "code", (gpointer)MAIN_EXIT_SAFE );
			gtk_signal_connect( GTK_OBJECT( exit_radio ) , "toggled", GTK_SIGNAL_FUNC( gsfdm_exit_radio_callback ), (gpointer)exit_dlg );
			
			gtk_box_pack_start( GTK_BOX( exit_dlg->vbox ), GTK_WIDGET( exit_radio = GTK_RADIO_BUTTON( 
				gtk_radio_button_new_with_label( gtk_radio_button_group( exit_radio ), 
				_( "... And close pppd" ) ) ) ), FALSE, FALSE, 5 );
			gtk_object_set_data( GTK_OBJECT( exit_radio ), "code", (gpointer)MAIN_EXIT_SHUTDOWN_PPPD );
			gtk_signal_connect( GTK_OBJECT( exit_radio ) , "toggled", GTK_SIGNAL_FUNC( gsfdm_exit_radio_callback ), (gpointer)exit_dlg );

			gtk_box_pack_start( GTK_BOX( exit_dlg->vbox ), GTK_WIDGET( exit_radio = GTK_RADIO_BUTTON( 
				gtk_radio_button_new_with_label( gtk_radio_button_group( exit_radio ), 
				_( "... And Shutdown host" ) ) ) ), FALSE, FALSE, 5 );
			gtk_object_set_data( GTK_OBJECT( exit_radio ), "code", (gpointer)MAIN_EXIT_SHUTDOWN_HOST );
			gtk_signal_connect( GTK_OBJECT( exit_radio ) , "toggled", GTK_SIGNAL_FUNC( gsfdm_exit_radio_callback ), (gpointer)exit_dlg );

			gtk_object_set_data( GTK_OBJECT( exit_dlg ), "code", (gpointer)MAIN_EXIT_ANYWAY );

			gtk_box_pack_start( GTK_BOX( exit_dlg->vbox ), gtk_hseparator_new(), FALSE, FALSE, 5 );
/*				
			gtk_box_pack_start( GTK_BOX( exit_dlg->vbox ), 
				( wid = gtk_check_button_new_with_label( _( "Stop anyway at :" ) ) ), FALSE, FALSE, 5 );
			gt_object_set_data( GTK_OBJECT( exit_dlg ), "date_check_widget", (gpointer)wid );
			gtk_box_pack_start( GTK_BOX( exit_dlg->vbox ), 
				( date_widget = gnome_date_edit_new( time( NULL ), TRUE, TRUE ) ), FALSE, FALSE, 5 );
			gt_object_set_data( GTK_OBJECT( exit_dlg ), "date_widget", (gpointer)wid );
*/
			gtk_box_pack_start( GTK_BOX( exit_dlg->vbox ), 
				( wid = gtk_check_button_new_with_label( _( "Stop Auto Download" ) ) ), FALSE, FALSE, 5 );
			gtk_object_set_data( GTK_OBJECT( exit_dlg ), "download_widget", (gpointer)wid );
			gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( wid ), TRUE );
			
			gtk_widget_show_all( GTK_WIDGET( exit_dlg ) );
		}
		
		// warm if canceled the scheduled exit
		if( exit_valided )
		{	exit_valided = FALSE;							// cancel exit schedule
			gsfdm_message_push_message( _( "WARNING : SCHEDULED EXIT CANCELED\n" ), TRUE, TRUE, TRUE );
			gtk_window_set_title( GTK_WINDOW( win ), GSFDM_APP_MAIN_NAME );
		}
		
		gtk_widget_show( GTK_WIDGET( exit_dlg ) );
		return;											// work delayed...
	}
	
	// no job anymore, don't need to prompt before exiting
	exit_valided = TRUE;
	gsfdm_main_real_exit( MAIN_EXIT_ANYWAY );
}

// *****************************************************************************
// callback when request for about window
static void	gsfdm_about( void )
{
static GtkWidget	*about_win = NULL;
static gchar const 	*authors[] = { "j.a.l@free.fr", NULL };
GtkWidget			*u;
GtkBox				*box;

	if( !about_win )
	{	about_win = gnome_about_new(
			_("GSFDM"), VERSION, "Copyright (C) 2002 / 02 FreeWare", authors,
			_( "Gnome plugable frontend to stream dowloader command line for linux. \
		This soft don't download anything by itself.\
		Authors decline all illegal use of this soft : It's intented for downloading of free data. \
		and not copyrighted" ), NULL );
		
		gnome_dialog_close_hides( GNOME_DIALOG( about_win ), TRUE );
		
		gtk_box_pack_start( GTK_BOX( GNOME_DIALOG( about_win )->vbox ),
			GTK_WIDGET( box = GTK_BOX( gtk_hbox_new( TRUE, 5 ) ) ), FALSE, TRUE, 0 );
		gtk_box_pack_start( box, ( u = gnome_href_new( "mailto:j.a.l@free.fr", 
			_( "Mail to J.A.L." ) ) ), FALSE, TRUE, 5 );
		gtk_widget_show( u );
		
		gtk_box_pack_start( GTK_BOX( GNOME_DIALOG( about_win )->vbox ), 
			( u = gnome_href_new( "http://j.a.l.free.fr.com/", 
			_( "Direct link to www page" ) ) ), TRUE, TRUE, 5 );
		gtk_widget_show( u );

		gtk_widget_show( GTK_WIDGET( box ) );
		GTK_BOX( GNOME_DIALOG( about_win )->vbox )->spacing = 0;
	}
	
	gtk_widget_show( about_win );
}

#define STREAM_SIZE 1000
// *****************************************************************************
static void	gsfdm_main_filesel_ok_callback( GtkFileSelection *dlg )
{	// fix me : not able to determine whether file name is const or not
gchar	*url = gtk_file_selection_get_filename( dlg );
	
	// check if this is really a file
	// fix me : read also from sochet is usefull
	if( gsfdm_file_get_file_type( url ) == GSFDM_FILE_TYPE_REGULAR )
	{	if( gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( gtk_object_get_data( GTK_OBJECT( dlg ), "list_widget" ) ) ) )
		{	// load as url list file
			FILE		*f;
			
			// open the file load all lines as url
			// first look if this is a text file
			if( ( f = fopen( url, "r" ) ) )
			{	// look whether this is a test file...
				size_t		i, size = STREAM_SIZE;
				gchar		*str = g_new0( char, size );
		
				fread( str, sizeof( gchar ), size, f );
				for( i = 0 ; i < size ; i++ )
				{	if( !isgraph( str[i] ) && !isspace( str[i] ) )
					{	gtk_widget_show( GTK_WIDGET( gnome_error_dialog_parented( _( "Binary file detected" ), GTK_WINDOW( win ) ) ) );
						fclose( f );
						g_free( str );
						gtk_widget_hide( GTK_WIDGET( dlg ) );
						return;
					}
				}

				// ok, load each line as an url def
				rewind( f );
				
				while( getline( &str, &size, f ) != -1 )
				{	gsfdm_url_push_url( str, 
						gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( gtk_object_get_data( GTK_OBJECT( dlg ), "dl_widget" ) ) ),
						gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( gtk_object_get_data( GTK_OBJECT( dlg ), "rn_widget" ) ) ) );
				}
	
				g_free( str );
				fclose( f );
				
			// error opening file...
			} else {
				gchar *tmp = g_strconcat( _( "Unable to load :\n" ), url, NULL );
				
				gtk_widget_show( GTK_WIDGET( gnome_error_dialog_parented( tmp, GTK_WINDOW( win ) ) ) );
				g_free( tmp );
			}
			
		
		} else {
			// this is an url def...
			gsfdm_url_push_url( url, 
				gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( gtk_object_get_data( GTK_OBJECT( dlg ), "dl_widget" ) ) ),
				gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( gtk_object_get_data( GTK_OBJECT( dlg ), "rn_widget" ) ) ) );
		}
		
	}else {
		gtk_widget_show( GTK_WIDGET( gnome_error_dialog_parented( _( "Not a regular file" ), GTK_WINDOW( win ) ) ) );
	}

	gtk_widget_hide( GTK_WIDGET( dlg ) );
}

// *****************************************************************************
//	open a new url from disk
// *****************************************************************************
static void	gsfdm_open_file( void )
{
static GtkFileSelection	*dlg = NULL;
GtkWidget	*c, *b, *f;
	
	if( !dlg )
	{	dlg = GTK_FILE_SELECTION( gtk_file_selection_new( _( "Open url from Disk File" ) ) );
		gtk_file_selection_hide_fileop_buttons( dlg );
 		gtk_window_set_position( GTK_WINDOW( dlg ), GTK_WIN_POS_MOUSE );
		
		gtk_box_pack_start( GTK_BOX( dlg->main_vbox ), ( f = gtk_frame_new( _( "Download oprions" ) ) ), FALSE, FALSE, 0 );
		gtk_container_add( GTK_CONTAINER( f ), ( b = gtk_hbox_new( TRUE, 0 ) ) );
		gtk_box_pack_start( GTK_BOX( b ), ( c = gtk_check_button_new_with_label( _( "Auto Download" ) ) ), FALSE, FALSE, 0 );
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( c ), gsfdm_config_get_auto_download() );
		gtk_object_set_data( GTK_OBJECT( dlg ), "dl_widget", (gpointer)( c ) );
		gtk_box_pack_end( GTK_BOX( b ), ( c = gtk_check_button_new_with_label( _( "Auto Rename" ) ) ), FALSE, FALSE, 0 );
		gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( c ), gsfdm_config_get_auto_rename() );
		gtk_object_set_data( GTK_OBJECT( dlg ), "rn_widget", (gpointer)( c ) );
		gtk_box_pack_start( GTK_BOX( dlg->main_vbox ), ( c = gtk_check_button_new_with_label( _( "Open as url list" ) ) ), FALSE, FALSE, 0 );
		gtk_object_set_data( GTK_OBJECT( dlg ), "list_widget", (gpointer)( c ) );
		gtk_widget_show_all( dlg->main_vbox );
		
		gtk_signal_connect_object( GTK_OBJECT( dlg->ok_button ), "clicked", GTK_SIGNAL_FUNC( gsfdm_main_filesel_ok_callback ), GTK_OBJECT( dlg ) );
		gtk_signal_connect_object( GTK_OBJECT( dlg->cancel_button ), "clicked", GTK_SIGNAL_FUNC( gtk_widget_hide ), GTK_OBJECT( dlg ) );
		gtk_signal_connect_object( GTK_OBJECT( dlg ), "delete_event", GTK_SIGNAL_FUNC( gtk_widget_hide ), GTK_OBJECT( dlg ) );
	}
	
	gtk_widget_show( GTK_WIDGET( dlg ) );
}

// *****************************************************************************
//	opne the configuration window
// *****************************************************************************
static void	gsfdm_config( void )
{
	gsfdm_config_open();					// nothing more !!!
}

// *****************************************************************************
//	switch the auto download flag on selected entries
// *****************************************************************************
static void	gsfdm_auto_dl( GtkWidget *widget )
{	
	allow_auto_dl = !allow_auto_dl;
	gsfdm_message_push_code( MESS_AUTO_DOWNLOAD, (gpointer)(allow_auto_dl) );
}

// *****************************************************************************
//	call the log window
// *****************************************************************************
static void	gsfdm_log( void )
{	gsfdm_log_open( );				// that all...
}

// *****************************************************************************
//	open the plugin configuration / state tool
// *****************************************************************************
static void gsfdm_plugin( void )
{	gsfdm_plugin_open_dlg( );
}

// *****************************************************************************
static void	gsfdm_main_save_ok_callback( GtkFileSelection *dlg )
{	// fix me : not able to determine whether file name is const or not
gchar	*url = gtk_file_selection_get_filename( dlg );
gchar	*tmp;
FILE	*fd;
	
	// test if file exist, what to do
	if( access( url , X_OK ) != -1 )
	{	if( gnome_dialog_run_and_close( GNOME_DIALOG( 
			gnome_question_dialog_parented( _( "FILE exist OVERWRITE ???" ), NULL, NULL, 
					GTK_WINDOW( gtk_widget_get_toplevel( GTK_WIDGET( dlg ) ) ) ) ) ) )
			{	// get out of here...
				gtk_widget_hide( GTK_WIDGET( dlg ) );
				return;
			}
	}		
	
	// now open file and write, overide if exist
	fd = fopen( url, "w+" );
	fputs( ( tmp = gsfdm_url_get_url_list() ), fd );
	fflush( fd );
	g_free( tmp );
	
	fclose( fd ); 
	gtk_widget_hide( GTK_WIDGET( dlg ) );
}

// *****************************************************************************
//	save the list of url into a disk file
// *****************************************************************************
static void	gsfdm_save_url_list( void )
{
static GtkFileSelection	*dlg = NULL;
	
	if( !dlg )
	{	dlg = GTK_FILE_SELECTION( gtk_file_selection_new( _( "Save url list on :" ) ) );
 		gtk_window_set_position( GTK_WINDOW( dlg ), GTK_WIN_POS_MOUSE );
		
		gtk_signal_connect_object( GTK_OBJECT( dlg->ok_button ), "clicked", GTK_SIGNAL_FUNC( gsfdm_main_save_ok_callback ), GTK_OBJECT( dlg ) );
		gtk_signal_connect_object( GTK_OBJECT( dlg->cancel_button ), "clicked", GTK_SIGNAL_FUNC( gtk_widget_hide ), GTK_OBJECT( dlg ) );
		gtk_signal_connect_object( GTK_OBJECT( dlg ), "delete_event", GTK_SIGNAL_FUNC( gtk_widget_hide ), GTK_OBJECT( dlg ) );
	}
	
	gtk_widget_show( GTK_WIDGET( dlg ) );	
}

// *****************************************************************************
//	function that just wrap main dock and gtk functions, simplify the menu
// *****************************************************************************
static void gsfdm_dock_url( void )
{ gsfdm_main_dock_op( MAIN_DOCK_URL_LIST ); }

// *****************************************************************************
static void gsfdm_dock_info( void )
{ gsfdm_main_dock_op( MAIN_DOCK_INFO ); }

// *****************************************************************************
static void gsfdm_dock_message( void )
{ gsfdm_main_dock_op( MAIN_DOCK_MESSAGE ); }

// *****************************************************************************
static void gsfdm_showhide_info( void )
{ gsfdm_main_showhide_op( MAIN_DOCK_INFO ); }

// *****************************************************************************
static void gsfdm_showhide_message( void )
{ gsfdm_main_showhide_op( MAIN_DOCK_MESSAGE ); }
